
%%%%%%%%%%%%%%%%%%%%%%%%%%%
% define some expressions %
% Computing corporate bond price QF  %
%%%%%%%%%%%%%%%%%%%%%%%%%%%

%disp('Computing asset prices')

    %% results of policy functions
currentN   = zeros(ncheb,ncheb);
currentC   = zeros(ncheb,ncheb);
currentU   = zeros(ncheb,ncheb);
currentK   = zeros(ncheb,ncheb);
currentB   = zeros(ncheb,ncheb);
currentQG   = zeros(ncheb,ncheb);
currentNd = currentN;
currentCd = currentC;
currentUd = currentU;
currentKd = currentK;
currentBd = currentB;
currentQGd = currentQG;

for i=1:ncheb
    for j=1:ncheb
        currentK(i,j)   = nodes_k(i) ;
        currentB(i,j)   = nodes_b(j) ;
        currentN(i,j)   = chebeval2(coeffs_N,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentC(i,j)   = chebeval2(coeffs_C,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentU(i,j)   = chebeval2(coeffs_U,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentQG(i,j)   = chebeval2(coeffs_QG,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ; 
        currentNd(i,j)   = chebeval2(coeffs_Nd,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentCd(i,j)   = chebeval2(coeffs_Cd,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentUd(i,j)   = chebeval2(coeffs_Ud,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ;
        currentQGd(i,j)   = chebeval2(coeffs_QGd,nodes_k(i),nodes_b(j),kbound,bbound,ncheb) ; 
    end
end

if nonnegativity==1
    currentN  = max(min(currentN,.999),1e-8) ;
    currentNd  = max(min(currentNd,.999),1e-8) ;
    currentC  = max(currentC,1e-8) ;
    currentCd  = max(currentCd,1e-8) ;
end

currentW = (1-alpha).*currentK.^alpha.*currentN.^(-alpha) ;
currentY  = currentK.^alpha.*currentN.^(1-alpha) ;
currentI = currentY - currentC ;
currentWd = (1-alpha).*(lambdaY*currentK).^alpha.*currentNd.^(-alpha) ;
currentYd  = (lambdaY*currentK).^alpha.*currentNd.^(1-alpha) ;
currentId = currentYd - currentCd ;

if nonnegativity==1
    currentI = max(1e-8, currentI);
    currentId = max(1e-8, currentId);
    currentC = currentY - currentI;
    currentCd = currentYd - currentId;
end

%%% for the other FOCs, need to know future values:
phiADJ = a_0 + a_1./(1-eta).*(currentI./currentK).^(1-eta); % the last part of this can create non-real number
phiprimetoday = a_1.*(currentI./currentK).^(-eta);
phiADJd = a_0 + a_1./(1-eta).*(currentId./currentK).^(1-eta); % the last part of this can create non-real number
phiprimetodayd = a_1.*(currentId./currentK).^(-eta);

%%% gov bond next period, (d for when disaster hits today,) if today in (ncheb,ncheb) and get tomorrow eps
Kprime = zeros(ncheb,ncheb,Neps);
Bprime = zeros(ncheb,ncheb,Neps);
Kprimed = zeros(ncheb,ncheb,Neps);
Bprimed = zeros(ncheb,ncheb,Neps);
for i=1:Neps
    Kprime(:,:,i) =  max(kboundREAL(1),min( ((1-delta).*currentK+phiADJ.*currentK)/(exp(mu+stdtfp*grideps(i))),kboundREAL(2)));
    bprime = (currentB + g)./currentQG;
    Bprime(:,:,i) =  max(bbound(1),min( bprime/exp(mu+stdtfp*grideps(i)) , bbound(2)));
    bprimed = (currentB + g)*(1-sum(omega))./currentQGd;
    Kprimed(:,:,i) =  max(kboundREAL(1),min( ((1-delta).*lambdaD.*currentK+phiADJd.*currentK)/(exp(mu+stdtfp*grideps(i))),kboundREAL(2)));
    Bprimed(:,:,i) =  max(bbound(1),min( bprimed/exp(mu+stdtfp*grideps(i)) , bbound(2))); 
    if normal_tax == 1
        % omegaC so that b' becomes target of b (Targetb)
        omegaC1 = 1 - Targetb./(currentB + g).*currentQG;
        TauC = omegaC1.*(currentB + g)./currentC;
        TauC = (TauC > MaxTauC).*MaxTauC + (TauC < 0).*0 ...
            + (1-(TauC > MaxTauC)).*(1-(TauC < 0)).*TauC;     
        Bprime(:,:,i) = ( currentB + g - TauC.*currentC )./currentQG/exp(mu+stdtfp*grideps(i)) ;
        Bprime(:,:,i) =  max(bbound(1),min( Bprime(:,:,i) , bbound(2)));
        Bprimed(:,:,i) = Bprime(:,:,i);
    end

end

futureN00 = chebeval2(coeffs_N,Kprime,Bprime,kbound,bbound,ncheb) ; %no disaster in t & t+1
futureC00 = chebeval2(coeffs_C,Kprime,Bprime,kbound,bbound,ncheb) ;
futureU00 = chebeval2(coeffs_U,Kprime,Bprime,kbound,bbound,ncheb) ;
futureN0d = chebeval2(coeffs_Nd,Kprime,Bprime,kbound,bbound,ncheb) ; % no in t & disaster in t+1
futureC0d = chebeval2(coeffs_Cd,Kprime,Bprime,kbound,bbound,ncheb) ;
futureU0d = chebeval2(coeffs_Ud,Kprime,Bprime,kbound,bbound,ncheb) ;
futureNd0 = chebeval2(coeffs_N,Kprimed,Bprimed,kbound,bbound,ncheb) ; % disaster in t & no in t+1
futureCd0 = chebeval2(coeffs_C,Kprimed,Bprimed,kbound,bbound,ncheb) ;
futureUd0 = chebeval2(coeffs_U,Kprimed,Bprimed,kbound,bbound,ncheb) ;
futureNdd = chebeval2(coeffs_Nd,Kprimed,Bprimed,kbound,bbound,ncheb) ; % disaster in t & t+1
futureCdd = chebeval2(coeffs_Cd,Kprimed,Bprimed,kbound,bbound,ncheb) ;
futureUdd = chebeval2(coeffs_Ud,Kprimed,Bprimed,kbound,bbound,ncheb) ;


if nonnegativity==1
    futureU00 = max(futureU00,1e-13) ;
    futureU0d = max(futureU0d,1e-13) ;
    futureUd0 = max(futureUd0,1e-13) ;
    futureUdd = max(futureUdd,1e-13) ;
    futureN00  = max(min(futureN00,.999),1e-6) ;
    futureN0d  = max(min(futureN0d,.999),1e-6) ;
    futureNd0  = max(min(futureNd0,.999),1e-6) ;
    futureNdd  = max(min(futureNdd,.999),1e-6) ;
end


futureY00 = Kprime.^alpha.*futureN00.^(1-alpha) ;
if nonnegativity==1
    futureC00 = min(futureY00*.999,max(futureC00,1e-6)) ;  % investment has to be above zero
end
futureI00 = futureY00 - futureC00 ;

futureY0d = (lambdaY*Kprime).^alpha.*futureN0d.^(1-alpha) ;
if nonnegativity==1
    futureC0d = min(futureY0d*.999,max(futureC0d,1e-6)) ;
end
futureI0d = futureY0d - futureC0d ;

futureYd0 = Kprimed.^alpha.*futureNd0.^(1-alpha) ;
if nonnegativity==1
    futureCd0 = min(futureYd0*.999,max(futureCd0,1e-6)) ;
end
futureId0 = futureYd0 - futureCd0 ;

futureYdd = (lambdaY*Kprimed).^alpha.*futureNdd.^(1-alpha) ;
if nonnegativity==1
    futureCdd = min(futureYdd*.999,max(futureCdd,1e-6)) ;
end
futureIdd = futureYdd - futureCdd ;

futurePHI00 =  alpha*futureY00./Kprime + (1 - delta) ;  % R^K(t+1)
futurePHI0d =  alpha*futureY0d./Kprime + (1 - delta)*lambdaD ;
futurePHId0 =  alpha*futureYd0./Kprimed + (1 - delta) ; 
futurePHIdd =  alpha*futureYdd./Kprimed + (1 - delta)*lambdaD ;
currentPHId =  alpha*currentYd./currentK + (1 - delta)*lambdaD ; %R^K(t) in disaster

% future tax rate in disaster
futureTauK0d = omega(1)*(Bprime+g)./( futurePHI0d.*Kprime ); 
futureTauC0d = omega(2)*(Bprime+g)./futureC0d; 
futureTauG0d = omega(3)*(Bprime+g)./Bprime; 
futureTauT0d = omega(4)*(Bprime+g); 
futureTauKdd = omega(1)*(Bprimed+g)./( futurePHIdd.*Kprimed ); 
futureTauCdd = omega(2)*(Bprimed+g)./futureCdd; 
futureTauGdd = omega(3)*(Bprimed+g)./Bprimed; 
futureTauGdd( ~isfinite(futureTauGdd) ) = 0;
futureTauTdd = omega(4)*(Bprimed+g); 

if normal_tax == 1      
    futureTauK0d = 0; futureTauC0d = 0; futureTauG0d = 0; futureTauT0d = 0; 
    futureTauKdd  =0; futureTauCdd = 0; futureTauGdd = 0; futureTauTdd = 0; 
    
    futureQG = chebeval2(coeffs_QG,Kprime,Bprime,kbound,bbound,ncheb);
    futureomegaC = 1 - Targetb./(Bprime + g).*futureQG;
    futureTauC = futureomegaC.*(Bprime + g)./futureC0d;
    futureTauC = (futureTauC > MaxTauC).*MaxTauC  ...
            + (futureTauC < 0).*0 ...
            + (1-(futureTauC > MaxTauC)).*(1-(futureTauC < 0)).*futureTauC;  
end

xdis0 = zeros(ncheb,ncheb,Neps); % given no disaster in t 
xdisd = zeros(ncheb,ncheb,Neps); % given disaster in t 
xdis0 = 1 - ((futureTauK0d < 1).*(futureTauG0d < 1).*(futureTauC0d < 1.e3));
xdisd = 1 - ((futureTauKdd < 1).*(futureTauGdd < 1).*(futureTauC0d < 1.e3));
futureTauK0d = min(futureTauK0d, 1); 
futureTauG0d = min(futureTauG0d, 1); 
futureTauKdd = min(futureTauKdd, 1); 
futureTauGdd = min(futureTauGdd, 1); 

% current tax in disaster
currentTauCd = omega(2)*(currentB+g)./currentCd; 

% disaster probability at t+1
% probD0*exp(probD1*b^G)
p0 = min(max(probD0*exp(probD1*Bprime) + xdis0, 0), 1); % given no disaster in t  
pd = min(max(probD0*exp(probD1*Bprimed) + xdisd, 0), 1); % given disaster in t    

% t+1 term in M_{t+1} excluding the term of beta and mu&eps_{t+1}
futureMU00 = futureC00.^(nu*(1-gamma)-1).*(1-futureN00).^((1-nu)*(1-gamma)) ;  %% term of (t+1) in M_{t+1} w/o disaster
futureMU0d = 1./(1+futureTauC0d).*futureC0d.^(nu*(1-gamma)-1).*(1-futureN0d).^((1-nu)*(1-gamma)) ;  %% term of (t+1) in M_{t+1} w/ disaster
futureMUd0 = futureCd0.^(nu*(1-gamma)-1).*(1-futureNd0).^((1-nu)*(1-gamma)) ;  
futureMUdd = 1./(1+futureTauCdd).*futureCdd.^(nu*(1-gamma)-1).*(1-futureNdd).^((1-nu)*(1-gamma)) ;  
if normal_tax == 1
    futureMU0d = 1./(1+futureTauC).*futureC0d.^(nu*(1-gamma)-1).*(1-futureN0d).^((1-nu)*(1-gamma)) ;  %% term of (t+1) in M_{t+1} w/ disaster
    futureMU00 = futureMU0d; futureMUd0 = futureMU0d; futureMUdd = futureMU0d;
end
% Et( ...esp * u_{t+1}^... )
Term_EU00 = futureU00 ;
Term_EU0d = futureU0d ;
Term_EUd0 = futureUd0 ;
Term_EUdd = futureUdd ;
% integral over eps and disaster prob 
Term_EU = squeeze(sum(Term_EU00.*DF.*(1-p0),3)) + squeeze(sum(Term_EU0d.*DF.*p0,3));
Term_EUd = squeeze(sum(Term_EUd0.*DF.*(1-pd),3)) + squeeze(sum(Term_EUdd.*DF.*pd,3));

% t term in M_{t+1}
intermMU = (currentC).^(nu*(1-gamma)-1).*(1-currentN).^((1-nu)*(1-gamma));
intermMUd = 1./(1+currentTauCd).*(currentCd).^(nu*(1-gamma)-1).*(1-currentNd).^((1-nu)*(1-gamma));
if normal_tax == 1
    intermMU = 1./(1+TauC).*(currentC).^(nu*(1-gamma)-1).*(1-currentN).^((1-nu)*(1-gamma));
    intermMUd = intermMU;
end
    
% t+1 term  in M_{t+1} when investing K for banks
Term_K00 = futureMU00.*futurePHI00;
Term_K0d = futureMU0d.*(1-futureTauK0d).*futurePHI0d;
Term_Kd0 = futureMUd0.*futurePHId0;
Term_Kdd = futureMUdd.*(1-futureTauKdd).*futurePHIdd;
% integral over eps and disaster prob 
Term_K = squeeze(sum(Term_K00.*DF2.*(1-p0),3)) + squeeze(sum(Term_K0d.*DF2.*p0,3));
Term_Kd = squeeze(sum(Term_Kd0.*DF2.*(1-pd),3)) + squeeze(sum(Term_Kdd.*DF2.*pd,3));

% t+1 term  in M_{t+1} when investing BG for banks
Term_QG00 = futureMU00 ;
Term_QG0d = futureMU0d.*(1-futureTauG0d) ;
Term_QGd0 = futureMUd0 ;
Term_QGdd = futureMUdd.*(1-futureTauGdd) ;
% integral over eps and disaster prob 
Term_QG = squeeze(sum(Term_QG00.*DF2.*(1-p0),3)) + squeeze(sum(Term_QG0d.*DF2.*p0,3));
Term_QGd = squeeze(sum(Term_QGd0.*DF2.*(1-pd),3)) + squeeze(sum(Term_QGdd.*DF2.*pd,3));

%%%%%%%%%%%%%%%%%%%
%%% Third FOC %%%
%%%%%%%%%%%%%%%%%%%
% Return on deposit
futureRD00 = ( futurePHI00.*Kprime + Bprime )./( Kprime+currentQG.*Bprime );
futureRD0d = ( (1-futureTauK0d).*futurePHI0d.*Kprime + (1-futureTauG0d).*Bprime )./( Kprime+currentQG.*Bprime );
futureRDd0 = ( futurePHId0.*Kprimed + Bprimed )./( Kprimed+currentQGd.*Bprimed );
futureRDdd  = ( (1-futureTauKdd).*futurePHIdd.*Kprimed + (1-futureTauGdd).*Bprimed )./( Kprimed+currentQGd.*Bprimed );
%the fraction of average real return at crisis
xi =  futureRD0d./futureRD00 ;
xid = futureRDdd./futureRDd0 ;

% t+1 term  in M_{t+1} when deposit for HH
Term_D00 = futureMU00.*futureRD00;
Term_D0d = futureMU0d.*futureRD0d;
Term_Dd0 = futureMUd0.*futureRDd0;
Term_Ddd = futureMUdd.*futureRDdd;
% integral over eps and disaster prob 
Term_D = squeeze(sum(Term_D00.*DF2.*(1-p0),3)) + squeeze(sum(Term_D0d.*DF2.*p0,3));
Term_Dd = squeeze(sum(Term_Dd0.*DF2.*(1-pd),3)) + squeeze(sum(Term_Ddd.*DF2.*pd,3));

%%%%%%%%%%% 
%%% Price QD  such that E(M) = 1/QD %%%
% integral over eps and disaster prob 
Term_QD = squeeze(sum(futureMU00.*DF2.*(1-p0),3)) + squeeze(sum(futureMU0d.*DF2.*p0,3));
Term_QDd = squeeze(sum(futureMUd0.*DF2.*(1-pd),3)) + squeeze(sum(futureMUdd.*DF2.*pd,3));

currentQD  = beta*Term_QD./(intermMU./phiprimetoday); 
currentQDd = beta*Term_QDd./(intermMUd./phiprimetodayd); 

%%% Check if HH does not directly hold BG %%%
CheckPos = intermMU./phiprimetoday - beta./currentQG.*Term_QG;
CheckPosd = intermMUd./phiprimetodayd - beta./currentQGd.*Term_QGd;

    
