function res = chebeval2(coeffs,pointeval1,pointeval2,bound1,bound2,ncheb)

% coeffs: coefficients for Z(x,y),
% pointval1: x value
% pointval2: y value
% returns the value Z(x,y)

%%% T(k,p_j) = sum( cij Ti(k) )

lowerbound1 = bound1(1);
upperbound1 = bound1(2);
lowerbound2 = bound2(1);
upperbound2 = bound2(2);


temp1 = (2*(pointeval1-lowerbound1)/(upperbound1-lowerbound1)-1);
temp2 = (2*(pointeval2-lowerbound2)/(upperbound2-lowerbound2)-1);

res = 0;
for i=1:ncheb
    for j=1:ncheb
        res = res + coeffs(i,j)*cos((i-1)*acos(temp1)).*cos((j-1)*acos(temp2))  ;
    end
end


%%%%%%%%%
%{
temp = (2*(pointeval1-lowerbound)/(upperbound-lowerbound)-1);

res = coeffs(:,pointeval2)'*cos((0:ncheb-1)'*acos(temp))  ;
%}