
%%%%%%%%%%%%%%%%%
% initial guess for coefficients %
% [k bg x]
%%%%%%%%%%%%%%%%%

%%% N
%cc1=[nstar*ones(1,P.ncheb);zeros(P.ncheb-1,P.ncheb)] ; %initial guess for labor says that it is constant for all k
cc1=[nstar zeros(1,P.ncheb-1);zeros(P.ncheb-1,P.ncheb)] ; %initial guess for labor says that it is constant for all k and bg
c1=reshape(cc1,P.ncheb*P.ncheb,1);

%%% C
temp=cstar/kstar;
test=myols(kpsi',temp*nodes_k);
cc2=[test.beta zeros(P.ncheb,P.ncheb-1)];
c2=reshape(cc2,P.ncheb*P.ncheb,1);

%%% U % value function
N_initial = zeros(P.ncheb,P.ncheb) ;
c_initial = zeros(P.ncheb,P.ncheb) ;
for i=1:P.ncheb
    for j=1:P.ncheb
        N_initial(i,j) =chebeval2(cc1,nodes_k(i),nodes_b(j),kbound,bbound,P.ncheb);  % N value for k and bg
        c_initial(i,j) =chebeval2(cc2,nodes_k(i),nodes_b(j),kbound,bbound,P.ncheb);  % C value for k and bg
    end
end
intialguessu = 1/(1-P.beta*exp(P.mu*P.nu*(1-P.gamma))).*(1-P.beta)*c_initial.^(P.nu*(1-P.gamma)).*(1-N_initial).^((1-P.nu)*(1-P.gamma)) ;

test1=myols(kpsi',intialguessu(:,1));
%test2=myols(psi',intialguessu(:,2));
cc3=[test1.beta zeros(P.ncheb,P.ncheb-1)];
c3 = reshape(cc3,P.ncheb*P.ncheb,1);

%%% Government bond price
cc4 = [QBstar zeros(1,P.ncheb-1);zeros(P.ncheb-1,P.ncheb)] ; %initial guess says that it is constant for all k and bg
c4 = reshape(cc4,P.ncheb*P.ncheb,1);

%%% lambda
cc5 = [(1-P.lambdaY0)^(1/P.alpha) zeros(1,P.ncheb-1);zeros(P.ncheb-1,P.ncheb)] ; %initial guess says that it is constant for all k and bg
c5 = reshape(cc5,P.ncheb*P.ncheb,1);

if P.normal_tax == 1
    keep_in_guess = [c1;c2;c3;c4];
else
    c1 = [c1; c1]; % same coeff irrespective of disaster
    c2 = [c2; c2]; % same coeff irrespective of disaster
    c3 = [c3; c3]; % same coeff irrespective of disaster
    c4 = [c4; c4]; % same coeff irrespective of disaster
    c5 = reshape(cc5,P.ncheb*P.ncheb,1);
    keep_in_guess = [c1;c2;c3;c4;c5];
end

coeffs_all = keep_in_guess ;
