

P.showiters = 1 ; %%% show some results after each iteration
P.maxiter = 200 ; %%% maximum number of updating steps in quasi newton allowed
P.maxbackstep = 50 ; %%% maximum number of backsteps in the quasi newton allowed
P.precision = 1e-9 ; %%% sets precision when quasi newton is supposed to stop
P.prev = 0;

P.gamma = 1.5 ; %%%  inverse of IES  % psi in the paper!
P.alpha = .3 ; %%% capital share`
P.beta = .995; %.987 ; %%% discount factor
P.delta  = .08 ; %%% depreciation rate
P.mu = 0.0182;  %%% trend rate TFP
P.nu     = .3 ; %%% utility weight on consumption
P.stdtfp = .023; %%% TFP shock std deviation
P.eta = .0 ; %%% adj cost parameter
%%% diaster prob = 1/( 1+ (1/probD0-1)*exp(-probD1*b^G) ) % similar to logistic function
P.probD0 = 0.025; %%% d0
P.probD1 = 4; % d1
P.g = 0.014; %%% government expenditure

P.Np = 1 ; %8; %%% number of points to approximate the process for p   
P.Neps = 7 ; %%% grid to approximate std normal TPF shock
P.grideps = linspace(-2.3,2.3,P.Neps) ;
P.probeps = normpdf(P.grideps,0,1) ;
P.probeps = P.probeps/sum(P.probeps) ;

P.omegaK = 0.2015; %%% weight on capital tax when disaster
P.omegaC = 0.0181; %%% weight on consumption tax when disaster
P.omegaG = 0.0760; %%% weight on gov bond tax when disaster
P.omegaT = 0.0157; %%% weight on lump-sum tax when disaster
P.omega = [P.omegaK P.omegaC P.omegaG P.omegaT];
P.lambdaY0 = 0.062; %% max of inefficiency of capital use by HH in production
P.lambdaY1 = 0.154; %% slope of inefficiency of capital use by HH in production
P.lambdaD = 1-0.06074; %% inefficiency of capital use by HH in depreciation; lambdaD=lambda if 0

P.normal_tax = 0; % if 1, no difference between normal and disaster
P.MaxTauC = 0;
P.Targetb = 0;

%constant_L = 1 ; %%% if 1, corporate finance does not matter
%theta = 1.5 ;  %%% risk aversion % gamma in the paper!
%theta_b_nd = .7 ; %%% recovery on assets in normal times
%theta_b_d = .7 ; %%% recovery on assets in disasters
%sigma_idio_nd = .35; %.1925 ; %%% vol of idiosyncratic shocks in normal times
%sigma_idio_d = sigma_idio_nd ; %%% vol of idiosyncratic shocks in disasters
%chi = 1.042 ; %%% debt subsidy parameter
