


%%% this file solves the model for different parameter values

clear all ; clc ; close all ; rng('default');

set(0,'defaultAxesFontSize',12);
set(0,'defaultAxesFontName','century');
set(0,'defaultTextFontSize',12);
set(0,'defaultTextFontName','century');


%%%to calculate benchmark model only:
% listPP = 1 ;
 %%% % two state variables (k, bg) 
listPP = [1:11] ;
listPP = [100];

ss_sum = []; ss_prob_sum = [];
volcor1_sum = []; volcor2_sum = []; param_sum = []; ss_disaster_sum = []; 
AAA = [];

for indexPP=1:length(listPP)
    
    indexP = listPP(indexPP) ;
    
    disp(indexP)
    
    parameters_EZbenchmarkBKBTFPRAND ;
    
    listparam_tables_final ;    
    
    %parameters_EZbenchmarkBKBTFPRAND2 ; % Not for use 
        
    % It matters if there is adjustment cost for investment (eta nonzero)
    P.iks = exp(P.mu) - 1 + P.delta ;
    P.a_1 = P.iks^P.eta ;
    P.a_0 = P.iks - P.a_1*P.iks^(1-P.eta)/(1-P.eta) ;
    %recalc ; % Not for use 
    

    disp('solving...')
    P.nonnegativity = 1 ;

    %ncheboptions = [2;3;4;5]; % degrees of cheb polynomial
    %npoptions = (2:Np);
    
    P.omega0 = P.omega;
    if (P.omegaK+P.omegaC+P.omegaG)>0.2 && P.normal_tax == 0
        list_omega = [0 0.5 0.9  1];
    else
        list_omega = 1 ;
    end
    
    ncheboptions = [3;4;5]; % degrees of cheb polynomial
    if (P.normal_tax == 1) & (P.Targetb >= 1) 
        ncheboptions = [3;4;5;6;7]; 
    end
 
    valdisoptions = [.05,.1,.2,.3,.4,.5,.6,.7,.8,.9,1.0] ;
    
    nchebloop = 1 ;
    nomega = 1;
    disastersizeloop = 1 ;
    P.omega = [P.omega0(1:3)*list_omega(nomega) P.omega0(4) + (1-list_omega(nomega))*sum(P.omega0(1:3))];
    
    P.ncheb = ncheboptions(nchebloop) ;
    %valdis = valdisG*valdisoptions(disastersizeloop) ; % disaster size, Not for use 
    %bkval = bkff*valdis ; btfpval = btfpff*valdis ; % disaster size, Not for use 
    
    P.Np = 1 ;
    initial_steady_state ;
    klowerbound = 0.2*kstar ; %lower bound of the interval for the pol fn polynomials wrt k
    kupperbound = 1.2*kstar ; %upper bound
    blowerbound = 0.05 ; %lower bound of the interval for the pol fn polynomials wrt b^G
    bupperbound = 0.85; %upper bound
    
    if P.normal_tax == 1
        %blowerbound = 0.0 ;
        %kupperbound = 2*kstar ; %upper bound
        %blowerbound = Targetb*0.7 ; %lower bound of the interval for the pol fn polynomials wrt b^G
        %bupperbound = P.Targetb*1.3;
        %bupperbound = min(bupperbound, P.Targetb*2);
    end
    kbound = [klowerbound kupperbound];
    
    bbound = [blowerbound bupperbound];
    
    
    % 1st computation
    prelimfunction ;
    polysetup ;
    guessini ;
    stepp0 = .02 ;
    quasinewton_EZnew
    disp('============================================================================')
    showcoeffs
    disp('============================================================================')
    
    if P.prev == 0
        % omega increase
        for nomega=2:length(list_omega) ;

            stepp0 = .05;
            P.omega = [P.omega0(1:3)*list_omega(nomega) P.omega0(4) + (1-list_omega(nomega))*sum(P.omega0(1:3))];
            %recalc ;
            prelimfunction ;
            quasinewton_EZnew ;

            disp('============================================================================')
            showcoeffs
            fprintf('Loop over omega %6.4f  \n', list_omega(nomega))
            disp('============================================================================')
        end


        %%
        % cheb dimension increase
        for nchebloop=2:length(ncheboptions)
            stepp0 = .05 ;

            P.ncheb = ncheboptions(nchebloop);
            %recalc ;
            prelimfunction ;
            polysetup ;

            %%%%%%%%%%%%%%%%%%%%
            %%% Update guess %%%
            %%%%%%%%%%%%%%%%%%%%

            %%% evaluate the previous solution at the new grid, and store:
            if P.normal_tax == 1
                c1 = [reshape([coeffs_N zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c2 = [reshape([coeffs_C zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c3 = [reshape([coeffs_U zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c4 = [reshape([coeffs_QG zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                coeffs_all=[c1;c2;c3;c4];
            else
                c1 = [reshape([coeffs_N zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1]); reshape([coeffs_Nd zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c2 = [reshape([coeffs_C zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1]); reshape([coeffs_Cd zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c3 = [reshape([coeffs_U zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1]); reshape([coeffs_Ud zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c4 = [reshape([coeffs_QG zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1]); reshape([coeffs_QGd zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                c5 = [reshape([coeffs_lambda zeros(P.ncheb-1,1); zeros(1, P.ncheb)], [P.ncheb*P.ncheb, 1])];
                coeffs_all=[c1;c2;c3;c4;c5];
            end
            %%%
            
            quasinewton_EZnew ;

            disp('============================================================================')
            showcoeffs
            fprintf('Loop over ncheb %4i  \n', P.ncheb)
            disp('============================================================================')
        end
    elseif P.prev == 1 
            %omega = omega0;
   
            stepp0 = .05 ;
            nchebloop=3;
            P.ncheb = ncheboptions(nchebloop);
            %recalc ;
            prelimfunction ;
            polysetup ;
            
            coeffs_all = coeffs_all_prev;
            quasinewton_EZnew ;

            disp('============================================================================')
            showcoeffs
            fprintf('Loop over ncheb %4i  \n', P.ncheb)
            disp('============================================================================')

    end


%%    
    [fval V] = function_main_EZnew(coeffs_all, kboundREAL, bbound, nodes_k, nodes_b, kbound, bbound, P, DF, DF2) ;
    %asset_pricing2
    
    %eval(strcat('save tabSeptY',num2str(indexP)))
    
    num_sim = 1;
    simirf_run
    
%%
    param = [P.gamma, P.alpha, P.beta, P.delta, P.mu, P.nu, P.stdtfp, P.probD0, P.probD1, P.g, ...
        P.omegaK, P.omegaC, P.omegaG, P.omegaT, P.normal_tax, P.lambdaY0, P.lambdaY1, P.lambdaD];
    param_sum = [param_sum; param];
    
    eval(strcat('save tabSeptY',num2str(indexP)))
    
end
%% actual data

if indexP == 50
    readdataUS
else
    readdataJPN
end

%%
drawgraph
save  'tabSeptY_sum'   **_sum listPP T

%%
prob_morikawa = 1 - (1-0.25)^(1/15);
fileID = fopen('summary_SS.txt','w+');
fprintf(fileID, ' \t  b/y \t i \t  c \t  y \t  $R^G-1$ \t $R^K-R^G$ \t $R^D-R^G$ \t U \t Period U \t CDS(level) \t CDS(elast)  \t Prob Morikawa \t Prob HI  \n');
fprintf(fileID, 'Data \t %8.4f (%6.4f) \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f  \t %8.4f \t -- \t -- \t %8.4f  \t 1 \t %8.4f  \t -- \n', data.mean.net_B_Y, data.mean.gross_B_Y, data.mean.IY, data.mean.CY, 1, data.mean.bondspread, data.mean.creditspread, data.mean.depositspread, data.mean.CDS1, prob_morikawa);
fprintf(fileID, '\n');
fprintf(fileID, '\n');
fprintf(fileID, ' Excluding crises \n');
fprintf(fileID, 'Model \n');
ss_sum1 = ss_sum;
ss_sum1(:,2:4) = ss_sum(:,2:4)/ss_sum(1,4);
ss_sum1(:,8:9) = ( (ss_sum(:,8:9)./ss_sum(1,8:9)).^(1/P.nu) - 1 ); % welfare comparison in consumption unit
fprintf(fileID, '%2.0f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \n', [listPP', ss_sum1, ss_prob_sum]');
fprintf(fileID, ' Including crises \n');
fprintf(fileID, 'Model \n');
ss_disaster_sum1 = ss_disaster_sum;
ss_disaster_sum1(:,2:4) = ss_disaster_sum(:,2:4)/ss_disaster_sum(1,4);
ss_disaster_sum1(:,8:9) = ( (ss_disaster_sum(:,8:9)./ss_disaster_sum(1,8:9)).^(1/P.nu) - 1 ); % welfare comparison in consumption unit
fprintf(fileID, '%2.0f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \n', [listPP', ss_disaster_sum1]');

fprintf(fileID, '  \n \n');

fprintf(fileID, ' Excluding crises \n');
fprintf(fileID, ' \t   s(dY) \t  s(dI) \t  s(dC) \t  cor(Y,B/Y) \t  cor(I,B/Y) \t cor(dY,B/Y) \t  cor(dI,B/Y) \t  cor(I,$R^G-1$) \t  cor(I,$R^K-R^G$) \t  cor(I,$R^D-R^G$) \t cor(dY,$R^G-1$) \t  cor(dY,$R^K-R^G$) \t  cor(dY,$R^D-R^G$) \t  cor(dI,$R^G-1$) \t  cor(dI,$R^K-R^G$) \t  cor(dI,$R^D-R^G$) \n');
fprintf(fileID, 'Data  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \n', ...
    data.sigma.y, data.sigma.i, data.sigma.c, ...
    data.cor.yb(2,1), data.cor.ib(2,1), data.cor.dyb(2,1), data.cor.dib(2,1), ...
    data.cor.ibondspread(2,1), data.cor.icreditspread(2,1), data.cor.idepositspread(2,1), ...
    data.cor.dybondspread(2,1), data.cor.dycreditspread(2,1), data.cor.dydepositspread(2,1), ...
    data.cor.dibondspread(2,1), data.cor.dicreditspread(2,1), data.cor.didepositspread(2,1) );
fprintf(fileID, 'Model \n');
fprintf(fileID, '%2.0f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \n', [listPP', volcor1_sum]');
fprintf(fileID, ' Including crises \n');
fprintf(fileID, 'Model \t   s(dY) \t  s(dI) \t  s(dC) \t  cor(dY,B/Y) \t  cor(dI,B/Y) \t  cor(dY,$R^G-1$) \t  cor(dY,$R^K-R^G$) \t  cor(dY,$R^D-R^G$)  \n');
fprintf(fileID, '%2.0f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \n', [listPP', volcor2_sum]');

fprintf(fileID, '  \n \n');
fprintf(fileID, ' Parameters \n');
fprintf(fileID, 'Model \t gamma \t alpha \t beta \t delta \t mu \t nu \t stdtfp \t probD0 \t probD1 \t g \t omegaK \t omegaC \t omegaG \t omegaT \t normal_tax \t lambdaY0 \t lambdaY1 \t lambdaD \n');
fprintf(fileID, '%2.0f \t %8.4f  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f \t %8.4f \t %8.4f \t %8.4f \t %8.4f  \t %8.4f \t %8.4f \n', [listPP', param_sum]');

fclose(fileID);
