

fval = function_main_EZnew(coeffs_all, kboundREAL, bbound, nodes_k, nodes_b, kbound, bbound, P, DF, DF2) ;
fnorm=norm(fval,'inf');

jacobianfmodnew2;
jacinv = inv(jacinv) ;

iter = 0 ;
%precision = 1e-8 ;
maxbackstep = 50 ;

while fnorm>P.precision

    iter=iter+1;
    c0=coeffs_all;
    dc = -(jacinv*fval);
    
    step = stepp0 ;
    dc = step*dc ;
    fnormold=inf;
    
    for backstep=1:maxbackstep %now comes the backstepping part , see MF p.41        
        coeffs_all=c0+dc; 
        fvalnew = function_main_EZnew(coeffs_all, kboundREAL, bbound, nodes_k, nodes_b, kbound, bbound, P, DF, DF2) ;
        fnormnew = norm(fvalnew,'inf'); %finds
        if fnormnew<fnorm, break, end %if step dx was an improvement, no need for backstepping, go back to newton iteration
        if fnormold<fnormnew % if cutting in half made things worse, go back to old one.
            fvalnew=fvalold;
            fnormnew=fnormold;
            dc=dc*2;
            break
        end
        fvalold  = fvalnew;%if step dx was no improvement, cut step in half until we get to an improvement
        fnormold = fnormnew;
        dc = dc/2;
    end    
    coeffs_all = c0+dc;
    if any(isnan(coeffs_all)|isinf(coeffs_all)) %check if there are any NANs or infinity values
        error('Infinities or NaNs encountered.')
    end
    %if fnormnew>fnorm 
    if (fnormnew>fnorm ) || ( norm(fvalnew-fval,'inf') < eps*10)
        jacobianfmodnew2;%('function_main_EZnew',coeffs_all);
        %finds jacobian inverse numerically
        jacinv = inv(jacinv);
    else
        temp = jacinv*(fvalnew-fval);
        jacinv0 = jacinv;
        jacinv = jacinv + (dc-temp)*(dc'*jacinv/(dc'*temp));
        %updating mechanism for inverse jacobian, this is supposedly faster
        %than recalculating the jacobian.
    end
    if abs(imag(jacinv))<1e-6
        jacinv = real(jacinv);
    else
        disp('imaginary parts')
    end
    fval = fvalnew;
    fnorm = fnormnew;
    if P.showiters==1
        fprintf('%4i %4i %6.2e\n',[iter backstep fnorm]);
    end
    
    if iter == P.maxiter
        break
    end
end
