


load ..\data\data_us;
spread_data = csvread('..\data\spread_US.csv',1,0);

% save data
data.dY = Y_tab(2,2:end) - Y_tab(2,1:end-1);
data.dC = C_tab(2,2:end) - C_tab(2,1:end-1);
data.dI = I_tab(2,2:end) - I_tab(2,1:end-1);
data.creditspread = spread_data(:,3)'/100;
data.bondspread = spread_data(:,2)'/100;

data.mean.net_B_Y = nanmean( B_Y_tab(2,:) );
data.mean.gross_B_Y = nanmean( B_Y_tab(3,:) );
data.mean.creditspread = nanmean( data.creditspread );
data.mean.bondspread = nanmean( data.bondspread );
data.mean.CY = exp( nanmean( C_tab(2,:) - Y_tab(2,:) ) );
data.mean.IY = exp( nanmean( I_tab(2,:) - Y_tab(2,:) ) );

data.sigma.y = nanstd( data.dY );
data.sigma.c = nanstd( data.dC );
data.sigma.i = nanstd( data.dI );
data.sigma.creditspread = nanstd( data.creditspread );
data.sigma.bondspread = nanstd( data.bondspread );

data.cor.yb = corrcoef(data.dY(2:end)', B_Y_tab(2,2:end-1)', 'rows','complete'); % correlation between dY and B^G/Y(t-1)
data.cor.ib = corrcoef(data.dI(2:end)', B_Y_tab(2,2:end-1)', 'rows','complete'); % correlation between dI and B^G/Y(t-1)
data.cor.ycreditspread = corrcoef(data.dY', data.creditspread(19:end)', 'rows','complete'); 
data.cor.ybondspread = corrcoef(data.dY', data.bondspread(19:end)', 'rows','complete'); 
