
printyes = 0 ;

disp('Simulating the model')

%%
% find "steady-state":
T_sub = 45; % repeat T_sub
T = T_sub*50+1 ; 
kstartpt = .6*kstar ;
bstartpt = .05 ;
nsimul = 0;
simulation;
% true steady state
%ad1 = floor(T/3):(T-1);
ad1 = find( mod(1:(T-1),T_sub) > 1 )'; % exclude the sample in which b is reset to bstartpt
btruess = mean(b_path(ad1)); 
ktruess = mean(k_path(ad1)); 
b_ytruess = mean(b_path(ad1)./y_path(ad1)); 
k_ytruess = mean(k_path(ad1)./y_path(ad1)); 
itruess = mean(i_path(ad1)); 
ctruess = mean(c_path(ad1)); 
Ntruess = mean(N_path(ad1)); 
ytruess = mean(y_path(ad1)); 
spreadrdtruess = mean(spreadrd_path(ad1)); 
spreadrgtruess = mean(spreadrg_path(ad1)); 
spreadrktruess = mean(spreadrk_path(ad1)); 
iktruess = mean(ikpath(ad1)); 
Utruess = mean(U_path(ad1)); 
periodU_path = c_path.^(P.nu).*(1-N_path).^(1-P.nu);
periodUtruess = mean(periodU_path(ad1));

% the elasticity of CDS spread to b based on the model
ad2 = find( (mod(1:(T-1),T_sub) > 1) & (mod(1:(T-1),T_sub) < T_sub-5) )'; % exclude the sample in which b is reset to bstartpt & 0 to 5 years before crisis
xx = [ones(size(b_path(ad2))) log(b_path(ad2))];
[elasCDS,elasCDSint,r,rint,stats] = regress(log(CDS_path(ad2)),xx);
CDS1_path = CDS_path(ad2);
by1_path = b_path(ad2)./y_path(ad2);
p1_path = p_path(ad2);
% actual b/y between 2003 and 2006
ad3 = find( (by1_path > 0.66) & (by1_path < 0.73) )'; % exclude the sample in which b is reset to bstartpt
mean_cds1 = mean(CDS1_path(ad3));
% actual b/y between 2016 and 2030
ad4 = find( (by1_path > 1.21) & (by1_path < 1.21 + 0.0376*15 ) )'; % exclude the sample in which b is reset to bstartpt
probruess_morikawa = mean(p1_path(ad4+1));
% actual b/y in 2024, predicted in 2014
ad5 = find( (by1_path > 1.19 + 0.0376*10 ) & (by1_path < 1.19 + 0.0376*11 ) )'; % exclude the sample in which b is reset to bstartpt
probruess_hoshiito = mean(p1_path(ad5+1));
ss_prob_sum = [ss_prob_sum; mean_cds1, elasCDS(2), probruess_morikawa, probruess_hoshiito];


ss_sum = [ss_sum; b_ytruess, itruess, ctruess, ytruess, spreadrgtruess, spreadrktruess, spreadrdtruess, Utruess, periodUtruess];

%volatility & correlation excluding disaster period
dy = []; dc = []; di = []; dN = []; y_detrend=[]; i_detrend=[];
for j = ad1'
    if xpath(j) == 0
        dy = [dy dlogY(j)];
        dc = [dc dlogC(j)];
        di = [di dlogI(j)];
        dN = [dN dlogN(j)];
        y_detrend = [y_detrend y_path(j)]; 
        i_detrend = [i_detrend i_path(j)];        
    else
        dy = [dy NaN];
        dc = [dc NaN];
        di = [di NaN];
        dN = [dN NaN];
        y_detrend = [y_detrend NaN];
        i_detrend = [i_detrend NaN];
    end
end
    
ysigma = nanstd(dy); 
csigma = nanstd(dc); 
isigma = nanstd(di); 
Nsigma = nanstd(dN); 
dybcor = corrcoef(dy, b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between dY and B^G/Y
dibcor = corrcoef(di, b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between dI and B^G/Y
ybcor = corrcoef(y_detrend, b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between Y and B^G/Y
ibcor = corrcoef(i_detrend, b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between I and B^G/Y

dyspreadrdcor = corrcoef(dy, spreadrd_path(ad1), 'rows','complete'); % correlation between dY and deposit spread
dyspreadrgcor = corrcoef(dy, spreadrg_path(ad1), 'rows','complete'); % correlation between dY and bond spread
dyspreadrkcor = corrcoef(dy, spreadrk_path(ad1), 'rows','complete'); % correlation between dY and loan spread
dispreadrdcor = corrcoef(di, spreadrd_path(ad1), 'rows','complete'); % correlation between dI and deposit spread
dispreadrgcor = corrcoef(di, spreadrg_path(ad1), 'rows','complete'); % correlation between dI and bond spread
dispreadrkcor = corrcoef(di, spreadrk_path(ad1), 'rows','complete'); % correlation between dI and loan spread
ispreadrdcor = corrcoef(i_detrend, spreadrd_path(ad1), 'rows','complete'); % correlation between I and deposit spread
ispreadrgcor = corrcoef(i_detrend, spreadrg_path(ad1), 'rows','complete'); % correlation between I and bond spread
ispreadrkcor = corrcoef(i_detrend, spreadrk_path(ad1), 'rows','complete'); % correlation between I and loan spread

%volcor1_sum(indexP,:) = [ysigma csigma isigma Nsigma ybcor(1,2) ibcor(1,2) yspreadcor(1,2) yspreadrgcor(1,2)];
volcor1_sum = [volcor1_sum; ysigma isigma csigma ybcor(1,2) ibcor(1,2) dybcor(1,2) dibcor(1,2) ...
    ispreadrgcor(1,2) ispreadrkcor(1,2) ispreadrdcor(1,2) ...
    dyspreadrgcor(1,2) dyspreadrkcor(1,2) dyspreadrdcor(1,2) ...
    dispreadrgcor(1,2) dispreadrkcor(1,2) dispreadrdcor(1,2) ];

%volatility & correlation including disaster period
ysigma = std(dlogY(ad1)); 
csigma = std(dlogC(ad1)); 
isigma = std(dlogI(ad1)); 
Nsigma = std(dlogN(ad1)); 
ybcor = corrcoef(dlogY(ad1), b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between dY and B^G/Y
ibcor = corrcoef(dlogI(ad1), b_path(ad1)./y_path(ad1), 'rows','complete'); % correlation between dI and B^G/Y
yspreadrdcor = NaN; %corrcoef(dlogY(ad1), spreadrd_path(ad1), 'rows','complete'); % correlation between dY and deposit spread
yspreadrgcor = NaN; %corrcoef(dlogY(ad1), spreadrg_path(ad1), 'rows','complete');
yspreadrkcor = NaN; 

%volcor2_sum(indexP,:) = [ysigma csigma isigma Nsigma ybcor(1,2) ibcor(1,2) yspreadcor yspreadrgcor];
volcor2_sum = [volcor2_sum; ysigma isigma csigma ybcor(1,2) ibcor(1,2) yspreadrgcor yspreadrkcor yspreadrdcor];

%%
% include disaster
% find "steady-state":
T = 1001 ; 
kstartpt = .6*kstar ;
bstartpt = .05 ;
nsimul = 2;
simulation;
% true steady state
ad1 = floor(T/3):(T-1);
btruess = mean(b_path(ad1)); 
ktruess = mean(k_path(ad1)); 
b_ytruess = mean(b_path(ad1)./y_path(ad1)); 
k_ytruess = mean(k_path(ad1)./y_path(ad1)); 
itruess = mean(i_path(ad1)); 
ctruess = mean(c_path(ad1)); 
Ntruess = mean(N_path(ad1)); 
ytruess = mean(y_path(ad1)); 
spreadrdtruess = mean(spreadrd_path(ad1)); 
spreadrgtruess = mean(spreadrg_path(ad1)); 
spreadrktruess = mean(spreadrk_path(ad1)); 
iktruess = mean(ikpath(ad1)); 
Utruess = mean(U_path(ad1)); 
periodU_path = c_path.^(P.nu).*(1-N_path).^(1-P.nu);
periodUtruess = mean(periodU_path(ad1));

ss_disaster_sum = [ss_disaster_sum; b_ytruess, itruess, ctruess, ytruess, spreadrgtruess, spreadrktruess, spreadrdtruess, Utruess, periodUtruess];

AAA = [AAA U_path(ad1)];

%%
st = 101 ;
nsimul = 1;

%for nsimul = 1 : num_sim
    
%    disp(nsimul)    
    T = 51 ; 
    kstartpt= ktruess*exp(11.39/100) ; % start from K in 1990 using JIP database
    bstartpt= 0.05 ;
    if indexP == 50
        bstartpt = 0.2;
    end
    
    simulation;    
    
    keepres1(nsimul,:) = [std(dlogY(st:end-2)),std(dlogC(st:end-2)),std(dlogI(st:end-2)),std(dlogN(st:end-2))] ;
    keepres4(nsimul,:) = [mean(spreadrd_path(st:end-2)), mean(spreadrg_path(st:end-2)), std(spreadrd_path(st:end-2)), std(spreadrg_path(st:end-2))] ;  
    keepres12(nsimul,:) = [mycov(ikpath(st:end-2),spreadrd_path(st:end-2)), mycov(ikpath(st:end-2),spreadrg_path(st:end-2))] ;
        
    
    keep_ss(nsimul,:) = mean([k_path(st:end-2),c_path(st:end-2),y_path(st:end-2),i_path(st:end-2),N_path(st:end-2)]) ;
    
    % 
    b_path_sum(indexP,:) = b_path;
    k_path_sum(indexP,:) = k_path;
    i_path_sum(indexP,:) = i_path;
    N_path_sum(indexP,:) = N_path;
    c_path_sum(indexP,:) = c_path;
    y_path_sum(indexP,:) = y_path;
    lambda_path_sum(indexP,:) = lambda_path;
    spreadrd_path_sum(indexP,:) = spreadrd_path;
    spreadrg_path_sum(indexP,:) = spreadrg_path;
    spreadrk_path_sum(indexP,:) = spreadrk_path;
    futureTauK_path_sum(indexP,:) = futureTauK_path;
    futureTauG_path_sum(indexP,:) = futureTauG_path;
    x_path_sum(indexP,:) = xpath;
    ik_path_sum(indexP,:) = ikpath;
    z_path_sum(indexP,:) = zpath;
    p_path_sum(indexP,:) = p_path;
    xi_path_sum(indexP,:) = xi_path;
    futurePHI0_path_sum(indexP,:) = futurePHI0_path;
    futurePHId_path_sum(indexP,:) = futurePHId_path;
    futureRD0_path_sum(indexP,:) = futureRD0_path;
    futureRDd_path_sum(indexP,:) = futureRDd_path;
    futureRD_path_sum(indexP,:) = futureRD_path;
    futurePHI_path_sum(indexP,:) = futurePHI_path;
    futureRG_path_sum(indexP,:) = futureRG_path;
    CDS_path_sum(indexP,:) = CDS_path;
%end

if num_sim > 100
    disp('===================================================')
    disp('Simulations: Sample without disasters')
    disp('===================================================')
    disp('std: dlogY, dlogC, dlogI, dlogN')
    mean(keepres1,1)
    disp('std, rel to std dlogY: C,I,N')
    disp('mean spread: RF-RG, RG-1; vol spread: RF-RG, RG-1')
    mean(keepres4,1)
    disp('cov w inv: spread RF-RG, RG-1')
    mean(keepres12,1)
    disp('===================================================')
end
