
% this file reproduces figure 2,3,4 of the paper

clear all

for ixi=1:4
    
    if ixi==1
        load tabSeptY6 % benchmark ;
    end
    if ixi==2
        load tabSeptY7 % cst leverage
    end
    if ixi==3
        load tabSeptY8 % state-dependent ;
    end
    if ixi==4
        load tabSeptY3 % rbc (chi=theta=1) ;
    end
    
    
    printyes = 0 ;
    
    disp('Simulating the model')
    
    num_sim = 20000 ;
    
    Tx = 31 ;
    T = Tx ;
    ap = 0 ;
    
    if ap==1
        keepres1 = zeros(num_sim,T) ;
        keepres2 = zeros(num_sim,T) ;
        keepres3 = zeros(num_sim,T) ;
        keepres4 = zeros(num_sim,T) ;
        keepres5 = zeros(num_sim,T) ;
        keepres6 = zeros(num_sim,T) ;
        keepres7 = zeros(num_sim,T) ;
        keepres8 = zeros(num_sim,T) ;
        keepres9 = zeros(num_sim,T) ;
        keepres10 = zeros(num_sim,T) ;
        keepres11 = zeros(num_sim,T) ;
        keepres12 = zeros(num_sim,T) ;        
    else
        keepres1 = zeros(T,1) ;
        keepres2 = zeros(T,1) ;
        keepres3 = zeros(T,1) ;
        keepres4 = zeros(T,1) ;
        keepres5 = zeros(T,1) ;
        keepres6 = zeros(T,1) ;
        keepres7 = zeros(T,1) ;
        keepres8 = zeros(T,1) ;
        keepres9 = zeros(T,1) ;
        keepres10 = zeros(T,1) ;
        keepres11 = zeros(T,1) ;
        keepres12 = zeros(T,1) ;
    end
    
    TstartShock = 2 ;
    [meanlogp,~] = fzero(@(x) findcorrectmeanY(x,sigmap,Np,rhop,targetmeanY),log(.017)-.1) ;
    
    
    for nsimul = 1 : num_sim ;
        
        if rem(nsimul,10)==1
            disp(nsimul)
        end
        
        ct = cumsum(invdis) ;
        %     startpt1 = kvecc(ggg) ;
        nodis = 1 ; irftfp = 0 ; irfprob = 0 ; irfdisaster = 0 ;
        T = 100 ;
        simulation ;
        
        Ts = 100 ;
        while abs(probpath(Ts-1)-pval(1))<1e-6||abs(probpath(Ts-1)-pval(end))<1e-6;
            Ts = Ts -1 ;
        end
        
        startpt1 = k_path(Ts-1) ;
        pvalstart = probpath(Ts-1) ;
        pvalstartindex = probpathdraw(Ts-1) ;
        
        nodis = 1 ; irftfp = 0 ; irfprob = 4 ; irfdisaster = 0 ;
        T = Tx ;
        
        
        % logp'=rho*logp+meanlogp*(1-rho)+eps
        
        
        targetshock = exp(meanlogp+ rhop*(log(pvalstart)-meanlogp)+ sigmap*sqrt(1-rhop^2)*1) ;
        xxs = pval - targetshock ;
        p_index_up = min(find(xxs>0)) ;
        p_index_down = max(find(xxs<0)) ;
        om2 = (targetshock-pval(p_index_up))/(pval(p_index_down)-pval(p_index_up)) ;
        
        if  rand(1)<om2
            ggg2 = p_index_down ;
        else
            ggg2 = p_index_up ;
        end
        
        
        simulation;
        
        
        if ap==1
            keepres1(nsimul,:) = i_1pathBp ;
            keepres2(nsimul,:) = y_1pathBp ;
            keepres3(nsimul,:) = z_1pathB ;
            keepres4(nsimul,:) = c_1pathBp ;
            keepres5(nsimul,:) = N_1pathBp ;
            keepres6(nsimul,:) = k_1pathBp ;
            keepres7(nsimul,:) = [mu,mu,dlogZ'] ;
            keepres8(nsimul,:) = probpath ;
            keepres9(nsimul,:) = xpath ;
            keepres10(nsimul,:) = def_path ;
            keepres11(nsimul,:) = spreadBAAAAA_path ;
            keepres12(nsimul,:) = L_path ;
        else
            keepres1 = i_1pathBp/num_sim + keepres1 ;
            keepres2 = y_1pathBp/num_sim + keepres2 ;
            keepres3 = z_1pathB/num_sim + keepres3 ;
            keepres4 = c_1pathBp/num_sim + keepres4 ;
            keepres5 = N_1pathBp/num_sim + keepres5 ;
            keepres6 = k_1pathBp/num_sim + keepres6 ;
            keepres7 = [mu,mu,dlogZ']'/num_sim + keepres7 ;
            keepres8 = probpath/num_sim + keepres8 ;
            keepres9 = xpath/num_sim + keepres9 ;
            keepres10 = def_path/num_sim + keepres10 ;
            keepres11 = spreadBAAAAA_path/num_sim + keepres11 ;
            keepres12 = L_path/num_sim + keepres12 ;
        end
        
        %
        %     keepres1(nsimul,:) = [std(dlogY(st:end-2)),std(dlogC(st:end-2)),std(dlogI(st:end-2)),std(dlogN(st:end-2))] ;
        %     keepres2(nsimul,:) = [mean(rfr_path(st:end-2)),mean(govtbondreturn_path(st:end-2)),mean(bondreturnAAA_path(st:end-2)),mean(bondreturnBAA_path(st:end-2)),mean(equityreturn_path(st:end-2))] ;
        %     keepres3(nsimul,:) = [std(rfr_path(st:end-2)),std(govtbondreturn_path(st:end-2)),std(bondreturnAAA_path(st:end-2)),std(bondreturnBAA_path(st:end-2)),std(equityreturn_path(st:end-2))] ;
        %     keepres4(nsimul,:) = [mean(spreadBAAAAA_path(st:end-2)),mean(spreadBAAGOV_path(st:end-2)),mean(spreadBAARF_path(st:end-2)),std(spreadBAAAAA_path(st:end-2)),std(spreadBAAGOV_path(st:end-2)),std(spreadBAARF_path(st:end-2))] ;
        %     keepres5(nsimul,:) = [mean(L_path(st:end-2)),std(L_path(st:end-2)), mean(100*def_path(st:end-2)), std(100*def_path(st:end-2)) ] ;
        %     keepres5AAA(nsimul,:) = [mean(LAAA_path(st:end-2)),std(LAAA_path(st:end-2)), mean(100*def_pathAAA(st:end-2)), std(100*def_pathAAA(st:end-2)) ] ;
        %
        %     keepres6(nsimul,:) = [mycorr(spreadBAAAAA_path(st:end-2), hpfilty(log(Y_1path(st:end-2)'))),...
        %                           mycorr(spreadBAAGOV_path(st:end-2), hpfilty(log(Y_1path(st:end-2)'))),...
        %                           mycorr(spreadBAARF_path(st:end-2), hpfilty(log(Y_1path(st:end-2)')))] ;
        %
        %     keepres6B(nsimul,:) = [mycorr(L_path(st:end-2), hpfilty(log(Y_1path(st:end-2)')))] ;
        %     keepres7(nsimul,:) = [mycorr(dlogY(st:end-2),dlogC(st:end-2)),mycorr(dlogY(st:end-2),dlogI(st:end-2)),mycorr(dlogC(st:end-2),dlogI(st:end-2)),mycorr(dlogY(st:end-2),dlogN(st:end-2)),mycorr(dlogN(st:end-2),dlogC(st:end-2)),mycorr(dlogN(st:end-2),dlogI(st:end-2))] ;
        %
        %     keepres8(nsimul,:) = [mean(loss_rate(st:end-2)),std(loss_rate(st:end-2))] ;
        %     keepres8AAA(nsimul,:) = [mean(loss_rateAAA(st:end-2)),std(loss_rateAAA(st:end-2))] ;
        %
        %     keepres9(nsimul,:) = [mean(spreadBAAAAA_path(st:end-2)),mean(exp_excreturn_bondBAAAAA_path(st:end-2)),mean(exp_payoff_bondAAA_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))];
        %     keepres10(nsimul,:) = [std(spreadBAAAAA_path(st:end-2)),std(exp_excreturn_bondBAAAAA_path(st:end-2)),std(exp_payoff_bondAAA_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))];
        %
        %         keepres9b(nsimul,:) = [mean(spreadBAAGOV_path(st:end-2)),mean(exp_excreturn_bondBAAGOV_path(st:end-2)),mean(exp_payoff_bondGOV_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))];
        %     keepres10b(nsimul,:) = [std(spreadBAAGOV_path(st:end-2)),std(exp_excreturn_bondBAAGOV_path(st:end-2)),std(exp_payoff_bondGOV_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))];
        %
        %         keepres9c(nsimul,:) = [mean(spreadBAARF_path(st:end-2)),mean(exp_excreturn_bondBAARF_path(st:end-2)),mean(1-exp_payoff_bondBAA_path(st:end-2))];
        %     keepres10c(nsimul,:) = [std(spreadBAARF_path(st:end-2)),std(exp_excreturn_bondBAARF_path(st:end-2)),std(1-exp_payoff_bondBAA_path(st:end-2))];
        %
        % %     keepres11(nsimul,:) = [mycov(spreadBAAAAA_path(st:end-2),spreadBAAAAA_path(st:end-2)),mycov(spreadBAAAAA_path(st:end-2),exp_excreturn_bond_path(st:end-2)),...
        % %         mycov(spreadBAAAAA_path(st:end-2),1-exp_payoff_bond_path(st:end-2))] ;
        % %
        %     keepres12(nsimul,:) = [mycov(ikpath(st:end-2),spreadBAAAAA_path(st:end-2)),mycov(ikpath(st:end-2),exp_excreturn_bondBAAAAA_path(st:end-2)),...
        %         mycov(ikpath(st:end-2),exp_payoff_bondAAA_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))] ;
        %     keepres12b(nsimul,:) = [mycov(ikpath(st:end-2),spreadBAAGOV_path(st:end-2)),mycov(ikpath(st:end-2),exp_excreturn_bondBAAGOV_path(st:end-2)),...
        %         mycov(ikpath(st:end-2),exp_payoff_bondGOV_path(st:end-2)-exp_payoff_bondBAA_path(st:end-2))] ;
        %     keepres12c(nsimul,:) = [mycov(ikpath(st:end-2),spreadBAARF_path(st:end-2)),mycov(ikpath(st:end-2),exp_excreturn_bondBAARF_path(st:end-2)),...
        %         mycov(ikpath(st:end-2),1-exp_payoff_bondBAA_path(st:end-2))] ;
        %
        %
        %     dl = dlogI ;
        %     %%% can take logs  but...
        %     spreadBAAAAA_path = 100*spreadBAAAAA_path ;
        %
        %     keep_philippon(nsimul,:) = [mycorr(spreadBAAAAA_path(1:end-2),dl),mycorr(spreadBAAAAA_path(2:end-1),dl),...
        % mycorr(spreadBAAAAA_path(1:end-2),hpfilty(log(I_1path(1:end-2)'))),mycorr(spreadBAAAAA_path(1:end-2),hpfilty(log(Y_1path(1:end-2)')))];
        %
        %     keep_philippon2(nsimul,:) = [mysreg(spreadBAAAAA_path(1:end-2),dl),mysreg(spreadBAAAAA_path(2:end-1),dl),...
        % mysreg(spreadBAAAAA_path(1:end-2),hpfilty(log(I_1path(1:end-2)'))),mysreg(spreadBAAAAA_path(1:end-2),hpfilty(log(Y_1path(1:end-2)')))];
        %
        %     keep_philippon3(nsimul,:) = [mycorr(log(spreadBAAAAA_path(1:end-2)),dl),mycorr(log(spreadBAAAAA_path(2:end-1)),dl),...
        % mycorr(log(spreadBAAAAA_path(1:end-2)),hpfilty(log(I_1path(1:end-2)'))),mycorr(log(spreadBAAAAA_path(1:end-2)),hpfilty(log(Y_1path(1:end-2)')))];
        %
        %     keep_philippon4(nsimul,:) = [mysreg(log(spreadBAAAAA_path(1:end-2)),dl),mysreg(log(spreadBAAAAA_path(2:end-1)),dl),...
        % mysreg(log(spreadBAAAAA_path(1:end-2)),hpfilty(log(I_1path(1:end-2)'))),mysreg(log(spreadBAAAAA_path(1:end-2)),hpfilty(log(Y_1path(1:end-2)')))];
        %
        %     keep_philippon5(nsimul,:) = [mycorr(hpfilty(log(spreadBAAAAA_path(1:end-2)')),dl),mycorr(hpfilty(log(spreadBAAAAA_path(2:end-1)')),dl),...
        % mycorr(hpfilty(log(spreadBAAAAA_path(1:end-2)')),hpfilty(log(I_1path(1:end-2)'))),mycorr(hpfilty(log(spreadBAAAAA_path(1:end-2)')),hpfilty(log(Y_1path(1:end-2)')))];
        %
        %     keep_philippon6(nsimul,:) = [mysreg(hpfilty(log(spreadBAAAAA_path(1:end-2)')),dl),mysreg(hpfilty(log(spreadBAAAAA_path(2:end-1)')),dl),...
        % mysreg(hpfilty(log(spreadBAAAAA_path(1:end-2)')),hpfilty(log(I_1path(1:end-2)'))),mysreg(hpfilty(log(spreadBAAAAA_path(1:end-2)')),hpfilty(log(Y_1path(1:end-2)')))];
        
    end
    
    if ap==1
        i_1pathBpAVG = mean(keepres1,1) ;
        y_1pathBpAVG = mean(keepres2,1) ;
        z_1pathBAVG = mean(keepres3,1) ;
        c_1pathBpAVG = mean(keepres4,1) ;
        N_1pathBpAVG = mean(keepres5,1) ;
        k_1pathBpAVG = mean(keepres6,1) ;
        zz_1pathBpAVG = mean(keepres7,1) ;
        probpathAVG = mean(keepres8,1) ;
        xpathAVG = mean(keepres9,1) ;
        def_pathAVG = mean(keepres10,1);
        spread1_pathAVG = mean(keepres11,1);
        L_pathAVG = mean(keepres12,1);
        
        
        y_1pathBpAVGsd = std(keepres2,1) ;
        z_1pathBAVGsd = std(keepres3,1) ;
        c_1pathBpAVGsd = std(keepsres4,1) ;
        N_1pathBpAVGsd = std(keepres5,1) ;
        k_1pathBpAVGsd = std(keepres6,1) ;
        zz_1pathBpAVGsd = std(keepres7,1) ;
        probpathAVGsd = std(keepres8,1) ;
        xpathAVGsd = std(keepres9,1) ;
        def_pathAVGsd = std(keepres10,1);
        spread1_pathAVGsd = std(keepres11,1);
        L_pathAVGsd = std(keepres12,1);
    else
        
        i_1pathBpAVG = keepres1 ;
        y_1pathBpAVG = keepres2 ;
        z_1pathBAVG = keepres3 ;
        c_1pathBpAVG = keepres4 ;
        N_1pathBpAVG = keepres5 ;
        k_1pathBpAVG = keepres6 ;
        zz_1pathBpAVG = keepres7 ;
        probpathAVG = keepres8 ;
        xpathAVG = keepres9 ;
        def_pathAVG = keepres10;
        spread1_pathAVG = keepres11;
        L_pathAVG = keepres12;
    end
    
    
    if ixi==1
        save resf
    end
    if ixi==2
        save newirfCSTLEV
    end
    if ixi==3
        save  newirfSC % state-dependent ;
    end
    if ixi==4
        save newirfRBC  % rbc (chi=theta=1) ;
    end
    
end