
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%% loop for simulation of a time series path
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

logzpath = zeros(T,1) ;
%[probpath, probpathdraw]=simulate_MC(Qd,pval,T,1); %arguments of simulation are transition matrix Qd, the grid i am using pval, # of periods, and the starting element, here it's the lowest p

if nsimul == 1
    epsshock = zeros(1,T);
else
    rng(nsimul);
    epsshock = randn(1,T);
end

k_path = zeros(T,1) ;
b_path = zeros(T,1) ;
i_path = zeros(T,1) ;
N_path = zeros(T,1);
QG_path = zeros(T,1);
lambda_path = zeros(T,1);
phi_path=zeros(T,1);
c_path=zeros(T,1);
y_path=zeros(T,1);
QF_path = zeros(T,1);
spreadrg_path=zeros(T,1); % spread of RG-1
spreadrk_path=zeros(T,1); % spread of RK-RG
spreadrd_path=zeros(T,1); % spread of RD-RG
futureTauK_path = zeros(T,1);
futurePHI0_path = zeros(T,1);
futurePHId_path = zeros(T,1);
xi_path = zeros(T,1);
futurelambda_path = zeros(T,1);
futureRD0_path = zeros(T,1);
futureRDd_path = zeros(T,1);
xpath = zeros(T,1) ;  % disaster
p_path = zeros(T,1); % disaster prob
U_path = zeros(T,1); % welfare
futureRD_path = zeros(T,1);
futurePHI_path = zeros(T,1);
futureRG_path = zeros(T,1);
futureM0_path = zeros(T,1);
futureMd_path = zeros(T,1);
CDS_path = NaN(T,1);

%%
k_path(1) = kstartpt ;
b_path(1) = bstartpt ;
logzpath(1) = P.stdtfp*epsshock(1) ;

xpath(1) = 0 ;  %start with no disaster

% disaster event 1
if nsimul == 1
    xpath = zeros(T,1);
    xpath(40) = 1;
    %xpath(20) = 1;
    %xpath(50) = 1;
    %xpath(90) = 1;
    for tt = 110:10:T
        xpath(tt) = 1;
    end
end

rng(nsimul+1000);
U = rand(1,T) ;
    
for t=2:T
    p0 = min(max(P.probD0*exp(P.probD1*b_path(t-1)), 0), 1); 
    if t > 2
        xdis = (futureTauK_path(t-2) >= 1) + (b_path(t-1) > bupperbound*1.5);  % if tax rate equals or higher than 1, default
    else
        xdis = 0;
    end
    p_path(t-1) = p0 + xdis;
    if nsimul ~= 1
        xpath(t) =  (U(t) < p_path(t-1)) ;
        %xpath(t) = min(1, xpath(t) + (b_path(t-1) > bupperbound*0.99)); 
    end
    if P.normal_tax == 1 
        xpath(t) = 0;
        p_path(t-1) = 0;
        coeffs_Cd = coeffs_C;
        coeffs_Nd = coeffs_N;
        coeffs_Ud = coeffs_U;
        coeffs_lambda = reshape([1 zeros(1,P.ncheb*P.ncheb-1)], P.ncheb, P.ncheb);
    end
    logzpath(t) = logzpath(t-1) + P.mu + P.stdtfp*epsshock(t);
    c_path(t-1) = (1-xpath(t-1))*chebeval2(coeffs_C,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) + xpath(t-1)*chebeval2(coeffs_Cd,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb);
    N_path(t-1) = (1-xpath(t-1))*chebeval2(coeffs_N,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) + xpath(t-1)*chebeval2(coeffs_Nd,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb);
    U_path(t-1) = ( (1-xpath(t-1))*chebeval2(coeffs_U,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) + xpath(t-1)*chebeval2(coeffs_Ud,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) )^(1/(1-P.gamma)) ; 
    lambda_path(t-1) = chebeval2(coeffs_lambda,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) ;
    if P.lambdaD == 1
        lambdaD = 1;
    else
        lambdaD = lambda_path(t-1);
    end
    %QG_path(t-1) = (1-xpath(t-1))*chebeval2(coeffs_QG,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb) + xpath(t-1)*chebeval2(coeffs_QGd,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb);
    % because no bond is issued at disaster, actually no price exists. We define QG = QG(-1)
    if xpath(t-1) == 0
        QG_path(t-1) = chebeval2(coeffs_QG,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb);
        if QG_path(t-1) < 0
            QG_path(t-1) = QG_path(t-2); %max(QG_path(t-1), 1.e-1);
        end
    else
        QG_path(t-1) = chebeval2(coeffs_QGd,k_path(t-1),b_path(t-1),kbound,bbound,P.ncheb);
        if QG_path(t-1) < 0
            QG_path(t-1) = QG_path(t-2); %max(QG_path(t-1), 1.e-1);
        end
    end
    y_path(t-1) = k_path(t-1).^(P.alpha)*N_path(t-1).^(1-P.alpha);
    i_path(t-1) = y_path(t-1) - c_path(t-1);
    phi_path(t-1) = P.a_0+P.a_1./(1-P.eta).*(i_path(t-1)./k_path(t-1)).^(1-P.eta);
    k_path(t) = ( (1-xpath(t-1))*(1-P.delta)*k_path(t-1) + xpath(t-1)*(1-P.delta)*lambdaD*k_path(t-1) + phi_path(t-1)*k_path(t-1) )/( exp(P.mu+P.stdtfp*epsshock(t)) );
    k_path(t) = real(k_path(t)) ;
    k_path(t) = max(kbound(1),min(kbound(2),k_path(t)))  ;
    b_path(t) = max(bbound(1), ...
        (1-xpath(t-1))*( b_path(t-1) + P.g )/QG_path(t-1)/exp( P.mu + P.stdtfp*epsshock(t) ) ...
        + xpath(t-1)*  ( b_path(t-1) + P.g )*(1-sum(P.omega))/QG_path(t-1)/exp( P.mu + P.stdtfp*epsshock(t) ) ...
        );
    if P.normal_tax == 1 
        omegaC1 = 1 - P.Targetb./(b_path(t-1) + P.g).*QG_path(t-1).*exp(P.mu);
        TauC = omegaC1.*(b_path(t-1) + P.g)./c_path(t-1);
        TauC = (TauC > P.MaxTauC).*P.MaxTauC + (TauC < 0).*0 ...
            + (1-(TauC > P.MaxTauC)).*(1-(TauC < 0)).*TauC;     
        b_path(t) = ( b_path(t-1) + P.g - TauC.*c_path(t-1) )./QG_path(t-1)/exp(P.mu+P.stdtfp*epsshock(t) ) ;
        b_path(t) =  max(blowerbound, min( b_path(t) , bupperbound));
    end
    if nsimul == 0
        if mod(t,T_sub)==1
            b_path(t) = bstartpt ; % reset b
        end
    end
    QD = interp2(nodes_k,nodes_b,V.currentQD',k_path(t-1),b_path(t-1), 'spline'); % strangely, we have to transpose the matrix when using interp2!
    QDd = interp2(nodes_k,nodes_b,V.currentQDd',k_path(t-1),b_path(t-1), 'spline');
    QD_path(t-1) = (1-xpath(t-1))*QD + xpath(t-1)*QDd;
    xi_path(t-1) = interp2(nodes_k,nodes_b,V.xi',k_path(t-1),b_path(t-1), 'spline') ;
    futureRD0_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureRD00(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureRDd0(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    futureRDd_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureRD0d(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureRDdd(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    spreadrd_path(t-1) = futureRD0_path(t-1) - 1/QG_path(t-1);
    spreadrg_path(t-1) = 1/QG_path(t-1) - 1;
    if P.normal_tax == 1
        futureTauG_path(t-1) = 0;
    else
        futureTauG_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureTauG0d(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline') ...
            + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureTauGdd(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    end
    
    if P.normal_tax == 1      
        futureTauK_path(t-1) = 0;
    else
        futureTauK_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureTauK0d(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline')...
            + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureTauKdd(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    end
    futurePHI0_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futurePHI00(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futurePHId0(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    futurePHId_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futurePHI0d(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futurePHIdd(:,:,floor((P.Neps+1)/2))',k_path(t-1),b_path(t-1), 'spline');
    futureRD_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureRD0',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureRDd',k_path(t-1),b_path(t-1), 'spline');
    futurePHI_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futurePHI0',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futurePHId',k_path(t-1),b_path(t-1), 'spline');
    futureRG_path(t-1) = (1-xpath(t-1))*interp2(nodes_k,nodes_b,V.futureRG0',k_path(t-1),b_path(t-1), 'spline') ...
        + xpath(t-1)*interp2(nodes_k,nodes_b,V.futureRGd',k_path(t-1),b_path(t-1), 'spline');
    spreadrk_path(t-1) = futurePHI0_path(t-1)-1-spreadrg_path(t-1);
    
    futureM0_path(t-1) = interp2(nodes_k,nodes_b,V.futureM0',k_path(t-1),b_path(t-1), 'spline');
    futureMd_path(t-1) = interp2(nodes_k,nodes_b,V.futureMd',k_path(t-1),b_path(t-1), 'spline');
end

for t=2:(T-5)
    CDS_LHS = 0; CDS_LHS2 = 1;
    CDS_RHS = 0; CDS_RHS2 = 1;
    for jj=0:4
        CDS_RHS2 = CDS_LHS2*( futureMd_path(t-1+jj)*p_path(t-1+jj) );
        CDS_RHS = CDS_RHS + CDS_RHS2;
        CDS_LHS2 = CDS_LHS2*( futureM0_path(t-1+jj)*(1-p_path(t-1+jj)) );
        CDS_LHS = CDS_LHS + CDS_LHS2;
    end
    CDS_path(t-1) = P.omegaG*CDS_RHS/CDS_LHS;
end
ikpath = i_path./k_path ;

zpath = exp(logzpath) ;
logzpath2 = logzpath - P.mu*(cumsum(ones(T,1))-1) ;
zpath2 = exp(logzpath2) ;
Y_1path = y_path.*zpath;
K_1path = k_path.*zpath;
I_1path = i_path.*zpath;
C_1path = c_path.*zpath;

dlogY = [0; log(Y_1path(2:end)) - log(Y_1path(1:end-1))];
dlogC = [0; log(C_1path(2:end)) - log(C_1path(1:end-1))];
dlogK = [0; log(K_1path(2:end)) - log(K_1path(1:end-1))];
dlogI = [0; log(I_1path(2:end)) -  log(I_1path(1:end-1))];
dlogN = [0; log(N_path(2:end)) - log(N_path(1:end-1))];
dlogZ = [0; log(zpath(2:end)) - log(zpath(1:end-1))] ;

%%

