


%%% this file solves the model for different parameter values

clear all ; clc ; close all ;


setparameters ;
parameters_EZbenchmarkBKBTFPRAND2 ;



%%%
recalc ;
disp('solving...')
nonnegativity = 0 ;

ncheboptions = [2;3;4;5]; % degrees of cheb polynomial
npoptions = (2:Np);

if theta>1.5
    list_theta = [.75,1.5,(2:1:theta)];
else
    list_theta = theta ;
end

if bkff==0
    list_theta = [.75,1.5,(2:.2:theta)];
    ncheboptions = [3;4;5]; % degrees of cheb polynomial
end

valdisoptions = [.05,.1,.2,.3,.4,.5,.6,.7,.8,.9,1.0] ;

nchebloop = 1 ;
ntheta =  1 ;
disastersizeloop = 1 ;
theta = list_theta(ntheta) ;
ncheb = ncheboptions(nchebloop) ;
valdis = valdisG*valdisoptions(disastersizeloop) ;
bkval = bkff*valdis ; btfpval = btfpff*valdis ;

Np = 1 ;
initial_steady_state ;
klowerbound = 0.2*kstar ; %lower bound of the interval for the pol fn polynomials
kupperbound = 2.0*kstar ; %upper bound
%     klowerbound = 0.4*kstar ; %lower bound of the interval for the pol fn polynomials
%     kupperbound = 5.0*kstar ; %upper bound
%     klowerbound = 0.5*kstar ; %lower bound of the interval for the pol fn polynomials
%     kupperbound = 2.0*kstar ; %upper bound
%     list_theta = theta ;
%     valdisoptions = [.1,.2,.3,.4,.5,.6,.7,linspace(.7,1,100)] ;

for nploop=1:length(npoptions)
    
    stepp0 = .02 ;
%     if indexP==28
%         stepp0 = .005 ;
%     end
    
    Np=npoptions(nploop) ;
    recalc ;
    prelimfunction ;
    
    %         initial_steady_state ;
    %
    %         klowerbound = 0.2*kstar ; %lower bound of the interval for the pol fn polynomials
    %         kupperbound = 2.0*kstar ; %upper bound
    
    
    polysetup ;
    
    if nploop==1&&ntheta==1
        guessini ;
    else
        if nploop>1
            %%% update guess:
            cc1=[coeffs_N,coeffs_N(:,Np-1)];
            c1=reshape(cc1,ncheb*Np,1);
            cc2=[coeffs_C,coeffs_C(:,Np-1)];
            c2=reshape(cc2,ncheb*Np,1);
            cc3=[coeffs_G,coeffs_G(:,Np-1)];
            c3=reshape(cc3,ncheb*Np,1);
            if constant_lev==0&&SC_opt==0
                cc4=[coeffs_L,coeffs_L(:,Np-1)];
                c4=reshape(cc4,ncheb*Np,1);
                coeffs_all=[c1;c2;c3;c4];
            elseif constant_lev==1&&SC_opt==0
                coeffs_all=[c1;c2;c3];
            elseif SC_opt==1
                cc4=[coeffs_L,coeffs_L(:,Np-1)];
                c4=reshape(cc4,ncheb*Np,1);
                coeffs_all=[c1;c2;c3;c4];
                for j=1:ndis
                    cc4b=[coeffs_Ld(:,:,j),coeffs_Ld(:,Np-1,j)];
                    c4b=reshape(cc4b,ncheb*Np,1);
                    coeffs_all=[coeffs_all;c4b] ;
                end
            end
        end
    end
    
    quasinewton_EZnew
    disp('============================================================================')
    showcoeffs
    disp('1st loop out of 3: over p')
    disp([nploop,length(npoptions)])
    disp('============================================================================')
end

for disastersizeloop=2:length(valdisoptions) ;
    
    %         if disastersizeloop>10
    %             stepp0 = .01 ;
    %         end
    %         if disastersizeloop>30
    %             stepp0 = .001 ;
    %         end
    
    
    valdis = valdisG*valdisoptions(disastersizeloop) ;
    %     valdis=valdisoptions(disastersizeloop,:);
    %
    %         if ndis>5
    %         ndis = 20 ;
    %         bkvalN = linspace(min(valdis),max(valdis),ndis) ;
    %         probdisN = interp1(valdis,probdisKK,bkvalN) ;
    %         probdisN = probdisN/sum(probdisN) ;
    %         probdis = probdisN ;
    %         valdis = bkvalN ;
    %         DeltaD = zeros(ndis,1) ;
    %         end
    
    bkval = bkff*valdis ;
    btfpval = btfpff*valdis ;
    
    recalc ;
    prelimfunction ;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% set initial guesses for coefficients %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    cc1= coeffs_N ;
    c1=reshape(cc1,ncheb*Np,1);
    cc2= coeffs_C ;
    c2=reshape(cc2,ncheb*Np,1);
    cc3= coeffs_G ;
    c3=reshape(cc3,ncheb*Np,1);
    
    if constant_lev==0&&SC_opt==0
        cc4= coeffs_L ;
        c4=reshape(cc4,ncheb*Np,1);
        coeffs_all=[c1;c2;c3;c4];
    elseif constant_lev==1&&SC_opt==0
        coeffs_all=[c1;c2;c3];
    elseif SC_opt==1
        cc4=coeffs_L;
        c4=reshape(cc4,ncheb*Np,1);
        coeffs_all=[c1;c2;c3;c4];
        for j=1:ndis
            cc4b=coeffs_Ld(:,:,j);
            c4b=reshape(cc4b,ncheb*Np,1);
            coeffs_all=[coeffs_all;c4b] ;
        end
    end
    
    quasinewton_EZnew ;
    disp('============================================================================')
    disp('Loop over disaster size')
    showcoeffs
    disp('Current disaster sizes')
    disp([disastersizeloop,length(valdisoptions)])
    disp('============================================================================')
end

for ntheta=2:length(list_theta) ;
    
    stepp0 = .05;
    
    theta = list_theta(ntheta) ;
    %if indexP==29
    %    gamma = theta ;
    %end
    recalc ;
    prelimfunction ;
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %% set initial guesses for coefficients %%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    cc1= coeffs_N ;
    c1=reshape(cc1,ncheb*Np,1);
    cc2= coeffs_C ;
    c2=reshape(cc2,ncheb*Np,1);
    cc3= coeffs_G ;
    c3=reshape(cc3,ncheb*Np,1);
    if constant_lev==0&&SC_opt==0
        cc4 = coeffs_L ;
        c4 = reshape(cc4,ncheb*Np,1);
        coeffs_all = [c1;c2;c3;c4];
    elseif constant_lev==1&&SC_opt==0
        coeffs_all=[c1;c2;c3];
    elseif SC_opt==1
        cc4=coeffs_L;
        c4=reshape(cc4,ncheb*Np,1);
        coeffs_all=[c1;c2;c3;c4];
        for j=1:ndis
            cc4b=coeffs_Ld(:,:,j);
            c4b=reshape(cc4b,ncheb*Np,1);
            coeffs_all=[coeffs_all;c4b] ;
        end
    end
    
    quasinewton_EZnew ;
    
    disp('============================================================================')
    showcoeffs
    disp('Loop over theta:grid')
    disp([ntheta,length(list_theta)])
    disp('============================================================================')
end

for nchebloop=2:length(ncheboptions)
    
    stepp0 = .05 ;
    
    ncheb = ncheboptions(nchebloop);
    recalc ;
    prelimfunction ;
    
    polysetup ;
    
    %%%%%%%%%%%%%%%%%%%%
    %%% Update guess %%%
    %%%%%%%%%%%%%%%%%%%%
    
    %%% evaluate the previous solution at the new grid, and store:
    N_val = zeros(ncheb,Np) ;
    c_val = zeros(ncheb,Np) ;
    Lev_val = zeros(ncheb,Np) ;
    G_val = zeros(ncheb,Np) ;
    if SC_opt==1
        Lev_valD = zeros(ncheb,Np,ndis) ;
    end
    
    for i=1:ncheb;
        for j=1:Np
            N_val(i,j) = chebeval2(coeffs_N,nodes_k(i),j,klowerbound,kupperbound,ncheb-1);
            c_val(i,j) = chebeval2(coeffs_C,nodes_k(i),j,klowerbound,kupperbound,ncheb-1);
            if constant_lev==0&&SC_opt==0
                Lev_val(i,j) = chebeval2(coeffs_L,nodes_k(i),j,klowerbound,kupperbound,ncheb-1);
            elseif constant_lev==1&&SC_opt==0
                Lev_val(i,j) = constant_lev_val ;
            elseif SC_opt==1
                Lev_val(i,j) = chebeval2(coeffs_L,nodes_k(i),j,klowerbound,kupperbound,ncheb-1);
                for jj=1:ndis
                    Lev_valD(i,j,jj)= chebeval2(squeeze(coeffs_Ld(:,:,jj)),nodes_k(i),j,klowerbound,kupperbound,ncheb-1);
                end
            end
            G_val(i,j) =chebeval2(coeffs_G,nodes_k(i),j,klowerbound,kupperbound,ncheb-1);  %%% !!! this is necheb-1 polynomial
        end
    end
    
    
    %%% Now fit a polynomial of degree ncheb given these values
    clear cc1 cc2 cc3 cc4 c1 c2 c3 c4
    for i=1:Np
        test = myols(psi',N_val(:,i)) ;
        cc1(:,i) = test.beta' ;
    end
    c1 = reshape(cc1,ncheb*Np,1) ;
    for i=1:Np
        test = myols(psi',c_val(:,i)) ;
        cc2(:,i) = test.beta' ;
    end
    c2 = reshape(cc2,ncheb*Np,1) ;
    
    for i=1:Np
        test = myols(psi',G_val(:,i)) ;
        cc3(:,i) = test.beta' ;
    end
    c3= reshape(cc3,ncheb*Np,1) ;
    
    if constant_lev==0&&SC_opt==0
        for i=1:Np
            test = myols(psi',Lev_val(:,i)) ;
            cc4(:,i) = test.beta' ;
        end
        c4 = reshape(cc4,ncheb*Np,1) ;
        coeffs_all=[c1;c2;c3;c4];
    elseif constant_lev==1&&SC_opt==0
        coeffs_all=[c1;c2;c3];
    elseif SC_opt==1
        for i=1:Np
            test = myols(psi',Lev_val(:,i)) ;
            cc4(:,i) = test.beta' ;
        end
        c4 = reshape(cc4,ncheb*Np,1) ;
        coeffs_all=[c1;c2;c3;c4];
        
        for jj=1:ndis
            cc4b = [] ;
            for i=1:Np
                test = myols(psi',squeeze(Lev_valD(:,i,jj))) ;
                cc4b(:,i) = test.beta' ;
            end
            c4b = reshape(cc4b,ncheb*Np,1) ;
            coeffs_all=[coeffs_all;c4b];
        end
    end
    
    quasinewton_EZnew ;
    
    disp('============================================================================')
    showcoeffs
    disp('Loop over ncheb:grid')
    disp([nchebloop,length(ncheboptions)])
    disp('============================================================================')
end

conspol = zeros(ncheb,Np);
Npol = zeros(ncheb,Np);
ypol = zeros(ncheb,Np);
invpol = zeros(ncheb,Np);
levpol = zeros(ncheb,Np);
Gpol = zeros(ncheb,Np);
if SC_opt==1
    levpolD = zeros(ncheb,Np,ndis);
end
if constant_lev==1&&SC_opt==0
    coeffs_L = [constant_lev_val*ones(1,Np);zeros(ncheb-1,Np)];
end

for i=1:ncheb
    for j=1:Np
        Npol(i,j) = chebeval2(coeffs_N,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
        conspol(i,j) = chebeval2(coeffs_C,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
        ypol(i,j) = nodes_k(i)^alpha*(Npol(i,j))^(1-alpha) ;
        invpol(i,j) = ypol(i,j) - conspol(i,j) ;
        levpol(i,j) = chebeval2(coeffs_L,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
        if SC_opt==1
            for jj=1:ndis
                levpolD(i,j,jj) = chebeval2(coeffs_Ld(:,:,jj),nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
            end
        end
        Gpol(i,j) = chebeval2(coeffs_G,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
    end
end

asset_pricing2
simirf_run


