

%% this file reproduces figure 5 of the paper 

clear all ;

for isis=1:2
    
    if isis==1
        load tabSeptY6
    else
        load tabSeptY7 ;
    end
    
    printyes = 1 ;
    
    disp(chi)
    
    ProbDefD = zeros(ncheb,Np) ;
    ProbDefND = zeros(ncheb,Np) ;
    levpol = zeros(ncheb,Np) ;
    currentI = zeros(ncheb,Np) ;
    currentC = zeros(ncheb,Np) ;
    currentY = zeros(ncheb,Np) ;
    futureKd = zeros(ncheb,Np,Neps,Np,ndis) ;
    futureNd = zeros(ncheb,Np,Neps,Np,ndis) ;
    futureK = zeros(ncheb,Np,Neps,Np) ;
    futureN = zeros(ncheb,Np,Neps,Np) ;
    currentN = zeros(ncheb,Np) ;
    CorrelT = zeros(ncheb,Np) ;
    ProbDefTot = zeros(ncheb,Np) ;
    
    for i=1:ncheb
        for j=1:Np
            levpol(i,j) = chebeval2(coeffs_L,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
            currentC(i,j) = chebeval2(coeffs_C,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
            currentN(i,j) = chebeval2(coeffs_N,nodes_k(i),j,klowerbound,kupperbound,ncheb) ;
            currentY(i,j) = nodes_k(i)^(alpha)*currentN(i,j)^(1-alpha) ;
            currentI(i,j) = currentY(i,j) - currentC(i,j) ;
            for i1=1:Neps
                for j2=1:Np
                    futureK(i,j,i1,j2) = ((1-delta).*nodes_k(i)+currentI(i,j))/(exp(mu+stdtfp*grideps(i1))) ;
                    futureN(i,j,i1,j2) = chebeval2(coeffs_N,futureK(i,j,i1,j2),j2,klowerbound,kupperbound,ncheb) ;
                    ProbDefND(i,j) =  ProbDefND(i,j) + probeps(i1)*Qd(j,j2)*bigHdsgefin( levpol(i,j)/((1-delta+alpha*futureK(i,j,i1,j2)^(alpha-1)*futureN(i,j,i1,j2)^(1-alpha))), sigma_idio_nd ) ;
                    
                    for jj=1:ndis
                        futureKd(i,j,i1,j2,jj) = (1-bkval(jj))/(1-btfpval(jj))*((1-delta).*nodes_k(i)+currentI(i,j))/(exp(mu+stdtfp*grideps(i1))) ;
                        futureNd(i,j,i1,j2,jj) = chebeval2(coeffs_N,futureKd(i,j,i1,j2,jj),j2,klowerbound,kupperbound,ncheb) ;
                        ProbDefD(i,j) =  ProbDefD(i,j) + probeps(i1)*Qd(j,j2)*probdis(jj)*bigHdsgefin( levpol(i,j)/((1-bkval(jj))*(1-delta+alpha*futureKd(i,j,i1,j2,jj)^(alpha-1)*futureNd(i,j,i1,j2,jj)^(1-alpha))), sigma_idio_d ) ;
                        CorrelT(i,j) = CorrelT(i,j) + ...
                            pval(j)*probeps(i1)*Qd(j,j2)*probdis(jj)*(bigHdsgefin( levpol(i,j)/((1-bkval(jj))*(1-delta+alpha*futureKd(i,j,i1,j2,jj)^(alpha-1)*futureNd(i,j,i1,j2,jj)^(1-alpha))), sigma_idio_d ))^2 ;
                    end
                    CorrelT(i,j) = CorrelT(i,j) +  ...
                        (1-pval(j))*probeps(i1)*Qd(j,j2)*(bigHdsgefin( levpol(i,j)/((1-delta+alpha*futureK(i,j,i1,j2)^(alpha-1)*futureN(i,j,i1,j2)^(1-alpha))), sigma_idio_nd ))^2 ;
                end
            end
            ProbDefTot(i,j) = ProbDefND(i,j)*(1-pval(j)) + pval(j)*ProbDefD(i,j) ;
        end
    end
    
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    % define some expressions %
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    disp('Computing asset prices')
    currentC   = conspol ;
    currentN   = Npol ;
    currentL   = levpol ;
    % currentG   = Gpol ;
    currentK   = nodes_k*ones(1,Np) ;
    currentI = invpol ;
    
    if SC_opt==1
        currentLd = levpolD ;
    end
    
    phi = a_0 + a_1./(1-eta).*(currentI./currentK).^(1-eta) ;  % !!!
    Kprime = zeros(ncheb,Np,Neps);
    Kprimed = zeros(ncheb,Np,Neps,ndis);
    for i=1:Neps
        Kprime(:,:,i) =  max(klowerboundREAL,min(  ((1-delta).*currentK+phi.*currentK)/(exp(mu+stdtfp*grideps(i))),kupperboundREAL));
    end
    for i=1:Neps
        for jj=1:ndis
            Kprimed(:,:,i,jj) = max(klowerboundREAL,min((1-bkval(jj))/(1-btfpval(jj))*((1-delta).*currentK+phi.*currentK)/(exp(mu+stdtfp*grideps(i))),kupperboundREAL));
        end
    end
    
    futureYd = zeros(ncheb,Np,Neps,ndis,Np);
    futureNd = zeros(ncheb,Np,Neps,ndis,Np);
    futureCd = zeros(ncheb,Np,Neps,ndis,Np);
    futureId = zeros(ncheb,Np,Neps,ndis,Np);
    futurePHId = zeros(ncheb,Np,Neps,ndis,Np);
    futureGd = zeros(ncheb,Np,Neps,ndis,Np);
    
    futureY = zeros(ncheb,Np,Neps,Np);
    futureN = zeros(ncheb,Np,Neps,Np);
    futureC = zeros(ncheb,Np,Neps,Np);
    futureI = zeros(ncheb,Np,Neps,Np);
    futurePHI = zeros(ncheb,Np,Neps,Np);
    futureG = zeros(ncheb,Np,Neps,Np);
    
    for i=1:ncheb
        for j=1:Np
            for j2=1:Np
                for ieps=1:Neps
                    for jj=1:ndis
                        futureNd(i,j,ieps,jj,j2) = chebeval2(coeffs_N,Kprimed(i,j,ieps,jj),j2,klowerbound,kupperbound,ncheb) ;
                        futureCd(i,j,ieps,jj,j2) = chebeval2(coeffs_C,Kprimed(i,j,ieps,jj),j2,klowerbound,kupperbound,ncheb) ;
                        futureGd(i,j,ieps,jj,j2) = chebeval2(coeffs_G,Kprimed(i,j,ieps,jj),j2,klowerbound,kupperbound,ncheb) ;
                    end
                    futureN(i,j,ieps,j2) = chebeval2(coeffs_N,Kprime(i,j,ieps),j2,klowerbound,kupperbound,ncheb) ;
                    futureC(i,j,ieps,j2) = chebeval2(coeffs_C,Kprime(i,j,ieps),j2,klowerbound,kupperbound,ncheb) ;
                    futureG(i,j,ieps,j2) = chebeval2(coeffs_G,Kprime(i,j,ieps),j2,klowerbound,kupperbound,ncheb) ;
                end
            end
        end
    end
    
    if nonnegativity==1
        futureG = max(futureG,1e-13) ;
        futureGd = max(futureGd,1e-13) ;
        futureN  = max(min(futureN,.999),1e-6) ;
        futureNd  = max(min(futureNd,.999),1e-6) ;
    end
    
    bigO = zeros(ncheb,Np,Neps,Np) ;
    bigOd = zeros(ncheb,Np,Neps,ndis,Np) ;
    Hofx = zeros(ncheb,Np,Neps,Np) ;
    Hofxd = zeros(ncheb,Np,Neps,ndis,Np) ;
    hofx = zeros(ncheb,Np,Neps,Np) ;
    hofxd = zeros(ncheb,Np,Neps,ndis,Np) ;
    Rofx = zeros(ncheb,Np,Neps,Np) ;
    Rofxd = zeros(ncheb,Np,Neps,ndis,Np) ;
    phiprime = zeros(ncheb,Np,Neps,Np) ;
    phiprimed = zeros(ncheb,Np,Neps,ndis,Np) ;
    
    for j=1:ncheb %loop for k
        for i=1:Np %loop for p
            for l=1:Neps
                for i2=1:Np
                    futureY(j,i,l,i2) = Kprime(j,i,l)^(alpha)*futureN(j,i,l,i2)^(1-alpha);
                    if nonnegativity==1
                        futureC(j,i,l,i2) = min(futureY(j,i,l,i2)*.999,max(futureC(j,i,l,i2),1e-6)) ;
                    end
                    %futureI(k,p,epsilon)
                    futureI(j,i,l,i2)  = Kprime(j,i,l).^(alpha).*futureN(j,i,l,i2).^(1-alpha)-futureC(j,i,l,i2) ;
                    phiprime(j,i,l,i2) = a_1*(futureI(j,i,l,i2)/Kprime(j,i,l))^(-eta) ;
                    futurePHI(j,i,l,i2)= (1-delta)/phiprime(j,i,l,i2) + alpha*Kprime(j,i,l)^(alpha-1)*futureN(j,i,l,i2)^(1-alpha) ;
                    
                    bigO(j,i,l,i2)=currentL(j,i)/(futurePHI(j,i,l,i2));
                    
                    Hofx(j,i,l,i2) = bigHdsgefin( bigO(j,i,l,i2), sigma_idio_nd ) ;
                    hofx(j,i,l,i2) = smallHdsgefin( bigO(j,i,l,i2), sigma_idio_nd ) ;
                    Rofx(j,i,l,i2) = bigRdsgefin( bigO(j,i,l,i2), sigma_idio_nd ) ;
                    for jj=1:ndis
                        futureYd(j,i,l,jj,i2) = Kprimed(j,i,l,jj)^(alpha)*futureNd(j,i,l,jj,i2)^(1-alpha);
                        if nonnegativity==1
                            futureCd(j,i,l,jj,i2) = min(futureYd(j,i,l,jj,i2)*.999,max(futureCd(j,i,l,jj,i2),1e-6)) ;
                        end
                        futureId(j,i,l,jj,i2) = Kprimed(j,i,l,jj).^(alpha).*futureNd(j,i,l,jj,i2).^(1-alpha)-futureCd(j,i,l,jj,i2) ;
                        phiprimed(j,i,l,jj,i2) = a_1*(futureId(j,i,l,jj,i2)/Kprimed(j,i,l,jj))^(-eta) ;
                        futurePHId(j,i,l,jj,i2) = (1-delta)/phiprimed(j,i,l,jj,i2) + alpha*Kprimed(j,i,l,jj)^(alpha-1)*futureNd(j,i,l,jj,i2)^(1-alpha) ;
                        if SC_opt==0
                            bigOd(j,i,l,jj,i2)=currentL(j,i)/((1-bkval(jj))*futurePHId(j,i,l,jj,i2));
                        else
                            bigOd(j,i,l,jj,i2)=currentLd(j,i,jj)/((1-bkval(jj))*futurePHId(j,i,l,jj,i2));
                        end
                        Hofxd(j,i,l,jj,i2) = bigHdsgefin( bigOd(j,i,l,jj,i2), sigma_idio_d ) ;
                        hofxd(j,i,l,jj,i2) = smallHdsgefin( bigOd(j,i,l,jj,i2), sigma_idio_d ) ;
                        Rofxd(j,i,l,jj,i2) = bigRdsgefin( bigOd(j,i,l,jj,i2), sigma_idio_d ) ;
                    end
                end
            end
        end
    end
    
    
    nextU=futureC.^(nu*(1-gamma)-1).*(1-futureN).^((1-nu)*(1-gamma));
    nextUd=futureCd.^(nu*(1-gamma)-1).*(1-futureNd).^((1-nu)*(1-gamma));
    
    expectation=zeros(ncheb,Np); %%% this is the expectation term which appears in the SDF
    for i_1=1:ncheb
        for j2=1:Np
            for j=1:Np
                for i=1:Neps
                    expectation(i_1,j) = expectation(i_1,j) + ...
                        probeps(i)*exp((1-theta)*nu*(mu+stdtfp*grideps(i)))*...
                        (1-pval(j))*Qnd(j,j2)*futureG(i_1,j,i,j2).^((1-theta)/(1-gamma)) ;
                    
                    for jj=1:ndis
                        expectation(i_1,j) = expectation(i_1,j) + ...
                            probeps(i)*exp((1-theta)*nu*(mu+stdtfp*grideps(i)))*...
                            Qd(j,j2)*probdis(jj)*(1-btfpval(jj))^(nu*(1-theta))*pval(j)*futureGd(i_1,j,i,jj,j2).^((1-theta)/(1-gamma)) ;
                    end
                end
            end
        end
    end
    
    
    %%% Define the SDF
    M_nd  = zeros(ncheb,Np,Neps,Np) ;
    M_d  = zeros(ncheb,Np,Neps,ndis,Np) ;
    for j=1:Np
        for i_1=1:ncheb
            for j2=1:Np
                for ieps=1:Neps
                    M_nd(i_1,j,ieps,j2) = beta*exp(((gamma-theta)*nu+nu*(1-gamma)-1)*(mu+stdtfp*grideps(ieps)))*nextU(i_1,j,ieps,j2)*futureG(i_1,j,i,j2)^((gamma-theta)/(1-gamma))/(currentC(i_1,j)^(nu*(1-gamma)-1)*(1-currentN(i_1,j))^((1-nu)*(1-gamma))*expectation(i_1,j)^((gamma-theta)/(1-theta)))  ;
                    
                    for jj=1:ndis
                        M_d(i_1,j,ieps,jj,j2)  = beta*exp(((gamma-theta)*nu+nu*(1-gamma)-1)*(mu+stdtfp*grideps(ieps)))*nextUd(i_1,j,ieps,jj,j2)*futureGd(i_1,j,i,jj,j2)^((gamma-theta)/(1-gamma))/(currentC(i_1,j)^(nu*(1-gamma)-1)*(1-currentN(i_1,j))^((1-nu)*(1-gamma))*expectation(i_1,j)^((gamma-theta)/(1-theta)))*(1-btfpval(jj))^((gamma-theta)*nu+nu*(1-gamma)-1) ;
                    end
                    %%% probeps(ieps)*Qd(j,j2)*pval(j)
                    %%% probeps(ieps)*(1-pval(j))*Qnd(j,j2)* ;
                end
            end
        end
    end
    
    
    condEXPSDF  = zeros(ncheb,Np) ;
    for j=1:Np
        for i_1=1:ncheb
            for j2=1:Np
                for ieps=1:Neps
                    condEXPSDF(i_1,j) =  condEXPSDF(i_1,j) +  probeps(ieps)*Qnd(j,j2)*(1-pval(j))*M_nd(i_1,j,ieps,j2) ;
                    for jj=1:ndis
                        condEXPSDF(i_1,j) =  condEXPSDF(i_1,j) + probdis(jj)*probeps(ieps)*(pval(j))*Qd(j,j2)*M_d(i_1,j,ieps,jj,j2) ;
                    end
                end
            end
        end
    end
    RFR = 1./condEXPSDF ;
    
    %%% corporate bond price
    q = zeros(ncheb,Np);
    exp_payoff_bond = zeros(ncheb,Np);
    exp_loss_rate = zeros(ncheb,Np);
    
    for j=1:Np
        for i_1=1:ncheb
            for j2=1:Np
                for ieps=1:Neps
                    exp_payoff_bond(i_1,j) = exp_payoff_bond(i_1,j) + probeps(ieps)*(1-pval(j))*Qnd(j,j2)*(1-Hofx(i_1,j,ieps,j2)+theta_b_nd*Rofx(i_1,j,ieps,j2)/bigO(i_1,j,ieps,j2))   ;
                    q(i_1,j) =  q(i_1,j) +  probeps(ieps)*(1-pval(j))*Qnd(j,j2)*M_nd(i_1,j,ieps,j2)*(1-Hofx(i_1,j,ieps,j2)+theta_b_nd*Rofx(i_1,j,ieps,j2)/bigO(i_1,j,ieps,j2))   ;
                    for jj=1:ndis
                        exp_payoff_bond(i_1,j) = exp_payoff_bond(i_1,j) + probdis(jj)*probeps(ieps)*Qd(j,j2)*pval(j)*(1-Hofxd(i_1,j,ieps,jj,j2)+theta_b_d*Rofxd(i_1,j,ieps,jj,j2)/bigOd(i_1,j,ieps,jj,j2)) ;
                        q(i_1,j) = q(i_1,j) + probdis(jj)*probeps(ieps)*Qd(j,j2)*pval(j)*M_d(i_1,j,ieps,jj,j2)*(1-Hofxd(i_1,j,ieps,jj,j2)+theta_b_d*Rofxd(i_1,j,ieps,jj,j2)/bigOd(i_1,j,ieps,jj,j2)) ;
                    end
                end
            end
        end
    end
    
    exp_loss_rate = (exp_payoff_bond-(1-ProbDefTot))./ProbDefTot  ;
    
    exp_return_bond = exp_payoff_bond./q ;
    exp_excreturn_bond = exp_return_bond - 1./condEXPSDF ;
    
    % figure;plot(pval,exp_return_bond')
    % figure;plot(pval,exp_excreturn_bond')
    % figure;plot(pval,q')
    % figure;plot(pval,spreadpol')
    % figure;plot(pval,exp_payoff_bond')
    % figure;plot(pval,ProbDefTot')
    % figure;plot(pval,ProbDefD')
    % figure;plot(pval,ProbDefND')    
    % AA = [ spreadpol(3,:);
    %         exp_excreturn_bond(3,:);
    %         1-exp_payoff_bond(3,:)]
    %     AA(1,:)-AA(2,:)-AA(3,:)
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %%% Share of expected defaults that will occur in disasters %%%
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    CorrelDef = zeros(ncheb,Np) ;
    for i=1:ncheb
        for j=1:Np
            CorrelDef(i,j) = (CorrelT(i,j) - ProbDefTot(i,j)^2)/(ProbDefTot(i,j)-ProbDefTot(i,j)^2) ;
            %         ProbDefTot(i,j) = ProbDefD(i,j) * pval(j) + (1-pval(j)) * ProbDefND(i,j) ;
            %         RelProbDef(i,j) = ( ProbDefD(i,j) * pval(j)  )/((1-pval(j)) * ProbDefND(i,j) +  ProbDefD(i,j) * pval(j)) ;
        end
    end
    
    % figure ; plot((pval),ProbDefTot(4,:)) ;
    % figure ; plot((pval),ProbDefND(4,:)) ;
    % figure ; plot((pval),ProbDefD(4,:)) ;
    
    if isis==1
        save CorrelDefKK CorrelDef
    else
        save CorrelDefKK2 CorrelDef pval
    end
    
end

clear all ;
load CorrelDefKK ; CorrelDefK  = CorrelDef ;
load CorrelDefKK2 ;

figure ; plot((pval(1:end)),CorrelDef(4,1:end),'o-','LineWidth',2)
hold on ; plot((pval(1:end)),CorrelDefK(4,1:end),'rx-','LineWidth',2)
grid on ; axis tight ;
ylabel('Correlation of Defaults','Fontsize',13)
xlabel('Probability of Disaster','Fontsize',13)
set(gca,'FontSize',13)
legend('Constant Leverage','Benchmark',4)
% print -depsc2 C:\systematicNEW.eps
